/*
 * PalmMameLoader.c
 *
 * main file for PalmMameLoader
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#include <TapWave.h>
#include <PalmOSGlue.h>
#include <PalmCompatibility.h>

#include "EndianUtils.h"
#include "PalmMameLoader.h"
#include "PalmMameLoader_Rsc.h"
#include "TWChars.h"
#include "stdfile.h"
#include "ColorPicker.h"
#include "TwChars.h"
#include "ljp_pnoload.h"
#include <PCENativeCall.h>


/*********************************************************************
 * Entry Points
 *********************************************************************/
static void MainViewLoadRecords(FormPtr frm);
static void MainViewLoadTable (FormPtr frm, UInt recordNum);
static void MainUpdateScrollers (FormPtr frm);
static void MainViewDrawRecord(VoidPtr tableP, SWord row, SWord column, 
	RectanglePtr bounds);
void MamePlayGame(Int16 GameNum, UInt8 Module);
Int16 CompareFunction (void *p1, void *p2, Int32 other);
void SetModuleName(Int16 ModNum);
void PushBOff(FormPtr frmP, Word PushButtonID);
void PushBOn(FormPtr frmP, Word PushButtonID);
Char* SafeStrCat ( Char *dst, const Char *src, UInt16 maxLengthWithNull, char *theFile, long theLine );
Char* SafeStrCopy (Char* dst, const Char* src, UInt16 maxLengthWithNull, char *theFile, long theLine) ;
Char * SafeStrIToA ( Char *s, Int32 i, UInt16 maxLengthWithNull, char *theFile, long theLine );
static Boolean OnSearchString (EventPtr event);
static Err AppStart(void);
void CheckForROMFiles();
Int16 CompareFoundFunction (void *p1, void *p2, Int32 other);
void GDrawBmp(int x, int y, int pic);
char MESSCommandLine[256];
/*********************************************************************
 * Global variables
 *********************************************************************/
//char FileList[1600][15];
char *FileList;
UInt32 wholesize;

typedef struct
{
	UInt16 driverIndex;
	UInt8 moduleIndex;
	char driverName[9];
	char driverLongName[31];
#ifdef _TAPWAVEBUILD_
	char manufacturer[9];
	char year[5];
	UInt8 vector;
#endif
} DriverListType;

DriverListType *DriverList;

typedef struct
{
	UInt16 driverIndex;
	UInt8 moduleIndex;
	char driverName[15];
	char driverLongName[31];
#ifdef _TAPWAVEBUILD_
	char manufacturer[9];
	char year[5];
	UInt8 vector;
#endif
	UInt8 Exists;
} DriverFoundType;

DriverFoundType *DriverFound;

Int16	GameIndex=-1;
UInt16	TotalGames = 0;
UInt16  TotalFoundGames = 0;
Word	RowsInTable;
Word	TopVisibleRow;
UInt32	ModuleName;
char FullModuleName[64];
//UInt32	SoundOption = 0;
//UInt32	RotateOption = 0;
//UInt8   ScaleOption = 0;
char	Searchcnd[10];
char	strCPUSpeed[4];
char	strAudioSpeed[4];
Int8	ShowAllGames = 0; //Show all 1, Show available 0
Int8	FilterOn = 0;
//UInt8	ScaleFlag=0;
//UInt8	MenuOption=0;
char	ConfabReturnString[30];
int		ConfabReturn = 0;
int		CountROMS = 0;
int 	SelectedRom=0;
//UInt8 	iAudioSpeed;
//UInt8	iCPUSpeed;
UInt8	Rating;
int		RomConfigReturn=0;
UInt32 displayFtrP;

typedef enum {
		FilterOff = 0,
		FilterVector,
		FilterAvailable
} ROMFilters;

typedef enum
{
	ConfigExit = 0,
	ConfigP1Credit,
	ConfigP1Start,
	ConfigUp,
	ConfigDown,
	ConfigLeft,
	ConfigRight,
	ConfigButton1,
	ConfigButton2,
	ConfigButton3,
	ConfigButton4,
	ConfigMenu,
	ConfigMenuSelect,
	ConfigPause,
	ConfigReset,
	ConfigLast
} ConfigKeyType;

char *ConfigKeysP[30];
char ConfigKeysText[30][40] = 
{ "Exit:             ",
"P1 Credit:        ",
"P1 Start:         ",
"Up:               ",
"Down:             ",
"Left:             ",
"Right:            ",
"Button1:          ",
"Button2:          ",
"Button3:          ",
"Button4:          ",
"Menu:             ",
"Menu Select:      ",
"Pause:            ",
"Reset:            "};

typedef struct
{
	UInt32 Key;
} KeyStructType;

KeyStructType KeyStruct[15];

typedef struct
{
	UInt8	iCPUSpeed;
	UInt8	iAudioSpeed;
	UInt32	SoundOption;
	UInt32	RotateOption;
	UInt8   ScaleOption;
	UInt8	MenuOption;
	UInt8   Rating;
} GameOptionType;

GameOptionType GameOption;


MemHandle	GDrawbmp_handle;
BitmapPtr	GDrawbmp;
WinHandle oldDrawWinH;
WinHandle OffScreenH;
RectangleType ScreenRect;
Int	screen_width, screen_height;
UInt8 *screenBufferP;
Int32 collapseVersion;
RGBColorType White, LightBlue, MedBlue, DarkBlue, Gray;
UInt8 g_InputDeviceUsed=0; // 0 build-in, 1 bt-gamepad, 2 ir-keyboard_targus, 3 IRpalm

/*********************************************************************
 * Internal Constants
 *********************************************************************/

/* Define the minimum OS version we support */
#define ourMinVersion    sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0)
#define kPalmOS20Version sysMakeROMVersion(2,0,0,sysROMStageDevelopment,0)
enum {
  hf_pin_present = 1              // has VG
  // 2, 4, 8, 16 ...
};
static UInt32 hw_flags = 0;

/*********************************************************************
 * Internal Functions
 *********************************************************************/
#define memNewChunkFlagNonMovable    0x0200
#define memNewChunkFlagAllowLarge    0x1000  // this is not in the sdk *g*
// Define the minimum OS version we support (5.0 for now).
#define kOurMinVersion	sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0)
#define kPalmOS10Version	sysMakeROMVersion(1,0,0,sysROMStageRelease,0)

SysAppInfoPtr 
SysGetAppInfo(SysAppInfoPtr *uiAppPP, SysAppInfoPtr *actionCodeAppPP)
  SYS_TRAP(sysTrapSysGetAppInfo); 


UInt32 host_event_handler ( UInt32 size );
UInt32 host_event_handler ( UInt32 size ) {

	return (UInt32)MemGluePtrNew(size);
}

UInt32 pnobridge_retval = 0;
UInt32 pnobridge_mask = 0;

UInt32 host_keyboard_handler ( UInt32 arg, UInt32 arg2 ) {
  UInt8 f;
  UInt32 a;
  static UInt32 accum = 0;

  // clear retval
  pnobridge_retval = 0;

  // normalize args
  f = arg & BRIDGEMASK;
  a = arg >> BRIDGESHIFT;

if ( f == BRIDGE_SrmSend )  {
  	hostcall_t *data;
  	data = (hostcall_t*)arg2;
  	
  	pnobridge_retval = SrmSend(data->a,
  					(const void *) data->b,
  					data->c,
  					(Err * ) data->d
  					);
  } else if ( f == BRIDGE_SrmReceive )  {
  	bighostcall_t *data;
  	data = (bighostcall_t*)arg2;
  	
  	pnobridge_retval = SrmReceive(data->a,
  					(void *) data->b,
  					data->c,
  					data->d,
  					(Err *) data->e
  					);
  } else if ( f == BRIDGE_SrmReceiveCheck )  {
  	hostcall_t *data;
  	data=(hostcall_t*)arg2;  	
  	pnobridge_retval = SrmReceiveCheck((SndStreamRef)(data->a),
  				(UInt32*)(data->b));
  }
  /*else if (f == BRIDGE_TreoKey)
  {
	UInt32 treokeys[3];
	hostcall_t *data;
	data = (hostcall_t*)arg2;

	HsKeyCurrentStateExt(treokeys);
	data->a = treokeys[0];
	data->b = treokeys[1];
	data->c = treokeys[2];

{
char debug[64];
StrPrintF(debug, "0x%lx 0x%lx 0x%lx", treokeys[0], treokeys[1], treokeys[2]);
WinDrawChars(debug, StrLen(debug), 0, 147);
}
*/
/*
	if (treokeys[1] || treokeys[2])
	{
		if (treokeys[1] & keyBitExt1Q) data->a = 0x80000000 | 'Q';
		else if (treokeys[1] & keyBitExt1W) data->a = 0x80000000 | 'W';
		else if (treokeys[1] & keyBitExt1Z) data->a = 0x80000000 | 'Z';
		else if (treokeys[1] & keyBitExt1U) data->a = 0x80000000 | 'U';
		else if (treokeys[1] & keyBitExt1I) data->a = 0x80000000 | 'I';
		else if (treokeys[1] & keyBitExt1O) data->a = 0x80000000 | 'O';
		else if (treokeys[1] & keyBitExt1P) data->a = 0x80000000 | 'P';
		else if (treokeys[1] & keyBitExt1A) data->a = 0x80000000 | 'A';
		else if (treokeys[1] & keyBitExt1S) data->a = 0x80000000 | 'S';
		else if (treokeys[1] & keyBitExt1H) data->a = 0x80000000 | 'H';
		else if (treokeys[1] & keyBitExt1J) data->a = 0x80000000 | 'J';
		else if (treokeys[1] & keyBitExt1K) data->a = 0x80000000 | 'K';
		else if (treokeys[1] & keyBitExt1L) data->a = 0x80000000 | 'L';
		else if (treokeys[1] & keyBitExt1Y) data->a = 0x80000000 | 'Y';
		else if (treokeys[1] & keyBitExt1B) data->a = 0x80000000 | 'B';
		else if (treokeys[1] & keyBitExt1N) data->a = 0x80000000 | 'N';
		else if (treokeys[1] & keyBitExt1M) data->a = 0x80000000 | 'M';
		else if (treokeys[1] & keyBitExt1Period) data->a = 0x80000000 | '.';
		else if (treokeys[1] & keyBitExt1Space) data->a = 0x80000000 | ' ';
		else if (treokeys[2] & keyBitExt2Symbol) data->a = 0x80000000 | '#';
		else if (treokeys[2] & keyBitExt2Launcher) data->a = 0x80000000 | '@';
		else if (treokeys[2] & keyBitExt2CmdMenu) data->a = 0x80000000 | '-';
		else if (treokeys[2] & keyBitExt2VolumeUp) data->a = 0x80000000 | 0xbb;
		else if (treokeys[2] & keyBitExt2VolumeDown) data->a = 0x80000000 | 0xab;
		else if (treokeys[1] & keyBitExt1E) data->a = 0x80000000 | '1';
		else if (treokeys[1] & keyBitExt1R) data->a = 0x80000000 | '2';
		else if (treokeys[1] & keyBitExt1T) data->a = 0x80000000 | '3';
		else if (treokeys[1] & keyBitExt1D) data->a = 0x80000000 | '4';
		else if (treokeys[1] & keyBitExt1F) data->a = 0x80000000 | '5';
		else if (treokeys[1] & keyBitExt1G) data->a = 0x80000000 | '6';
		else if (treokeys[1] & keyBitExt1X) data->a = 0x80000000 | '7';
		else if (treokeys[1] & keyBitExt1C) data->a = 0x80000000 | '8';
		else if (treokeys[1] & keyBitExt1V) data->a = 0x80000000 | '9';
		else if (treokeys[2] & keyBitExt2Null) data->a = 0x80000000 | '0';

		pnobridge_retval = 1;
	}

  }*/
  

  return ( pnobridge_retval );
}


UInt32 query_heap_free ( void ) {
  UInt16 heapid = 0;
  UInt32 max, bytes;

  MemHeapCompact (heapid );
  MemHeapFreeBytes ( heapid, &bytes, &max );

  //DEBUGS ( "heapfree" );
  //DEBUGU32 ( bytes );

  return ( bytes );
}

void *hw_query_vram ( void ) {
  WinHandle winh;
  BitmapType *winb;

  winh = WinGetDisplayWindow();
  winb = WinGetBitmap ( winh );

  return ( BmpGetBits ( winb ) );
}

static void hw_set_fullscreen ( UInt8 fullscreenp ) 
{
	EventType event;

  if ( fullscreenp ) {

    if ( hw_flags & hf_pin_present ) 
    {
        PINSetInputAreaState ( pinInputAreaClosed );
      	StatHide();
	    EvtGetEvent(&event,0);
	    while(event.eType != nilEvent)
	    {
	    	EvtGetEvent(&event,0);
	    	SysHandleEvent(&event);
	    }

    }

  } else {

    if ( hw_flags & hf_pin_present ) {
      StatShow();
    }

  }

  return;
}

void hw_guess_screen_dimensions ( /*UInt32 *r_width, UInt32 *r_height,
				   UInt32 *r_pitch*/ )
{
  /* WAIT; OS5 has WinScreenGetAttribute; life is good. */
  /* Process:
   * OS < 5
   *   ZOT requires OS5.
   *   Sony?
   *     If Sony, check Sony API .. its either low res, or we can ask API
   *   Non-Sony
   *     Is it a T|W? It should have DIA..
   *     If DIA, ask it.
   *     Otherwise, low res, bail.
   * OS >= 5
   *   DIA?
   *     If so, ask it.
   *   No DIA, so.. Sony?
   *     If Sony, ask it.
   *   No DIA, No Sony...
   *     Is it Treo? IF slo, low res
   *     If not Treo, must be high res (T|T1, T|T2)
   * Now, if new low res OS5 device comes out.. sucks.
   */
  UInt32 pitch = 0;
  UInt32 width = 0;
  UInt32 height = 0;
	UInt32 deviceID;
	char Temp1[30],Temp2[30],Temp3[30]; 

	Err devErr; 



  // is it double density or single density? this is only available in
  // Window Manager v4; OS5 includes v4 always, however.
  WinScreenGetAttribute ( winScreenRowBytes, &pitch );
  //   T|T3 returned 640b for pitch; 16bit -> 320px
  //   zodiac returns 960b; 16bit -> 480px
  WinScreenGetAttribute ( winScreenWidth, &width );
  WinScreenGetAttribute ( winScreenHeight, &height );
  // zodiac lies returns 320 width always
  
  StrCopy(Temp1,StrIToA(Temp1,pitch));
  StrCat(Temp1,"-");
  StrCopy(Temp2,StrIToA(Temp2,width));
  StrCat(Temp2,"-");
  StrCopy(Temp3,StrIToA(Temp3,height));


  //FrmCustomAlert(10024,Temp1,Temp2,Temp3);

  // deal with lies by using pitch..
  width = pitch / 2;
  pitch = pitch / 2;

  // Do we see a DIA present? (T|T3, Zodiac, UX50, Garmin, later devices..)
  {
    UInt32 version;
    Err err = FtrGet ( pinCreator, pinFtrAPIVersion, &version );
    if ( ! err && version ) {
      //PINS exists
      //DEBUGS("PIN present");
      hw_flags |= hf_pin_present;
      hw_set_fullscreen(1);

    } // pin?
  } // DIA PIN?

  // done
  //*r_width = width;
  //*r_height = height;
  //*r_pitch = pitch;
  
  devErr = FtrGet(sysFtrCreator, sysFtrNumOEMDeviceID, &deviceID); 
	if (deviceID == 'prmr')
	{
		width = 480;
		height = 320;
		pitch = 480;
	}

	FtrSet('PDac',1113,(unsigned long)width);
	FtrSet('PDac',1114,(unsigned long)height);
	FtrSet('PDac',1115,(unsigned long)pitch);


  return;
}
static void screen_init()
{
	UInt32	height, width, depth;
	Boolean  colour;
	//int i;
    UInt32 new_depth = 16;

	height = 320;
	width = 480;
	depth = 8;
	colour = true;
	

	WinScreenMode(winScreenModeSet,NULL,NULL,&new_depth,NULL);

#ifndef DEV_BUILD
	//SysSetOrientation(sysOrientationLandscape);
	//PINSetInputAreaState(1);
	//StatHide();
	displayFtrP =(UInt32)hw_query_vram();
	FtrSet('PDac',1111,(unsigned long)displayFtrP);
#endif
	FtrSet('PDac',1112,(unsigned long)host_event_handler);
	FtrSet('PDac',1116,(unsigned long)host_keyboard_handler);

	hw_guess_screen_dimensions();

}

static Err RomVersionCompatible(UInt32 requiredVersion, UInt16 launchFlags)
{
	UInt32 romVersion;
	// See if we're on in minimum required version of the ROM or later.
	FtrGet(sysFtrCreator, sysFtrNumROMVersion, &romVersion);
	if (romVersion < requiredVersion)
		{
		if ((launchFlags & (sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp)) ==
			(sysAppLaunchFlagNewGlobals | sysAppLaunchFlagUIApp))
			{
			FrmAlert (RomIncompatibleAlert);
		
			// Palm OS 1.0 will continuously relaunch this app unless we switch to 
			// another safe one.
			if (romVersion <= kPalmOS10Version)
				{
				AppLaunchWithCommand(sysFileCDefaultApp, sysAppLaunchCmdNormalLaunch, NULL);
				}
			}
		
		return sysErrRomIncompatible;
		}

	return errNone;
}

/*
 * FUNCTION: GetObjectPtr
 *
 * DESCRIPTION:
 *
 * This routine returns a pointer to an object in the current form.
 *
 * PARAMETERS:
 *
 * formId
 *     id of the form to display
 *
 * RETURNED:
 *     address of object as a void pointer
 */

static void * GetObjectPtr(UInt16 objectID)
{
	FormType * frmP;

	frmP = FrmGetActiveForm();
	return FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, objectID));
}

static void MyFormCopyLabel(FormPtr frmP,UInt16 objectID,char *text)
{

	RectangleType theRect;

// First erase the rectangle enclosing the label to remove the current text
FrmGetObjectBounds( frmP, FrmGetObjectIndex( frmP, objectID ), &theRect );
WinEraseRectangle( &theRect, 0 );

// Finally, copy the new text into the label
FrmCopyLabel( frmP, objectID, text ); 
}


Char* SafeStrCat ( Char *dst, const Char *src, UInt16 maxLengthWithNull, char *theFile, long theLine )
{
	UInt16   concatenated_length;
	//long   return_code;

	concatenated_length = StrLen ( dst ) + StrLen ( src );

	// First determine whether or not the concatenated length is greater than the maxLength

	if ( concatenated_length + 1 > maxLengthWithNull )
	{
		
		// Continue with the "safe" concatenation.
            // Note that StrNCat clips the destination string to n bytes including
            // the null character at the end, and it does append the null character.
		
		StrNCat ( dst, src, maxLengthWithNull );
		
	}  // if ( concatenated_length + 1 > maxLengthWithNull )

	// Just do the regular StrCat
	else
		StrCat ( dst, src );
		
	// return the destination
	return dst;
	
}  // SafeStrCat

Char* SafeStrCopy (Char* dst, const Char* src, UInt16 maxLengthWithNull, char *theFile, long theLine) 
{
	UInt16 srcLength;
	static long return_code;
	
	srcLength = StrLen(src);

	// First determine whether or not the source is greater than the maxLength

	if (srcLength + 1 > maxLengthWithNull )
	{
		
		// Continue with the "safe" copy
		
		StrNCopy ( dst, src, maxLengthWithNull - 1 );
		
		// Make sure we null terminate
		
		*(dst + maxLengthWithNull) = '\0';

	}  // if (srcLength + 1 > maxLengthWithNull )

	// Just do the regular StrCopy
	else
		StrCopy(dst, src);
		
	// return the destination
	return dst;
	
}  // SafeStrCopy
Char * SafeStrIToA ( Char *s, Int32 i, UInt16 maxLengthWithNull, char *theFile, long theLine )
{
      char   StrIToA_result [ maxStrIToALen ];
	UInt16   StrIToA_result_length;
	//long   return_code;
	
      // Determine what the actual destination string length WILL be.

	StrIToA ( StrIToA_result, i );

	StrIToA_result_length = StrLen ( StrIToA_result );

	// First determine whether or not the concatenated length is greater than the maxLength

	if ( StrIToA_result_length + 1 > maxLengthWithNull )
	{
		// Continue with the "safe" StrIToA.
		
		StrNCopy ( s, StrIToA_result, maxLengthWithNull - 1 );
		
		// Make sure we null terminate
		
		*(s + maxLengthWithNull) = '\0';
		
	}  // if ( StrIToA_result_length + 1 > maxLengthWithNull )

	// Just do the regular StrIToA 
	else
		StrIToA ( s, i );
		
	// return the destination
	return s;
	
}  // SafeStrIToA

/***********************************************************************
 *
 * FUNCTION:    SetFieldString
 *
 * DESCRIPTION: This routine is the funtion for adding text string into 
 *				    search edit field.
 *
 * PARAMETERS:  char* ch - the string that is to set to the field
 *
 * RETURNED:    none
 *
 * REVISION HISTORY:
 *
 *			Name		Date				Description
 *			----		----				-----------
 *			JL 		2000-10-05		Initial Revision
 *
 ***********************************************************************/
static void SetFieldString(char* ch)
{
	// allocate a handle
	VoidHand h = MemHandleNew(8);
	// lock the handle
	CharPtr  d = (CharPtr)MemHandleLock(h);
	// get the field's pointer
	FieldPtr field = (FieldPtr)GetObjectPtr(MainSearchField);
	// get the old handle
	VoidHand oldText = FldGetTextHandle(field);
	// deep copy the passing parameter into the new memory block
	if(oldText != 0)
	{  
		if(StrLen(FldGetTextPtr(field))>=8)
		{
	  		SafeStrCopy(d, FldGetTextPtr(field),9,__FILE__,__LINE__);
			d[8] = '\0';
		}
		else
		{
			StrCopy(d, FldGetTextPtr(field));
			StrCat(d, ch);
		}
	}
	else
	{
		StrCopy(d, ch);
	}
	// unlock the handle
	MemHandleUnlock(h);
	// assign the handle to a field
	FldSetTextHandle(field, (Handle)h);
	// free old handle
	if(oldText != 0)
	{
		MemHandleFree(oldText);
	}
	// redraw field
	FldDrawField(field);
}

static void SetString(char* ch, UInt16 objectID)
{
	// allocate a handle
	VoidHand h = MemHandleNew(8);
	// lock the handle
	CharPtr  d = (CharPtr)MemHandleLock(h);
	// get the field's pointer
	FieldPtr field = (FieldPtr)GetObjectPtr(objectID);
	// get the old handle
	VoidHand oldText = FldGetTextHandle(field);
	// deep copy the passing parameter into the new memory block
	if(oldText != 0)
	{  
		if(StrLen(FldGetTextPtr(field))>=4)
		{
	  		SafeStrCopy(d, FldGetTextPtr(field),4,__FILE__,__LINE__);
			d[8] = '\0';
		}
		else
		{
			StrCopy(d, FldGetTextPtr(field));
			StrCat(d, ch);
		}
	}
	else
	{
		StrCopy(d, ch);
	}
	// unlock the handle
	MemHandleUnlock(h);
	// assign the handle to a field
	FldSetTextHandle(field, (Handle)h);
	// free old handle
	if(oldText != 0)
	{
		MemHandleFree(oldText);
	}
	// redraw field
	FldDrawField(field);
}

static void SetAppColours()
{
	RGBColorType Black,Green;
	
	White.r = 255;
	White.g = 255;
	White.b = 255;
	
	LightBlue.r = 189;
	LightBlue.g = 213;
	LightBlue.b = 240;
	
	MedBlue.r = 50;
	MedBlue.g = 133;
	MedBlue.b = 203;
	
	DarkBlue.r = 14;
	DarkBlue.g = 76;
	DarkBlue.b = 123;
	
	Gray.r = 221;
	Gray.g = 232;
	Gray.b = 247;
	
	WinIndexToRGB(colorMagicMint,&Green);
	WinIndexToRGB(colorBlack,&Black);



	//AK - List of all possible colour changes

	/*	typedef enum UIColorTableEntries {
		UIObjectFrame = 0,
		UIObjectFill,
		UIObjectForeground,
		UIObjectSelectedFill,
		UIObjectSelectedForeground,
		UIMenuFrame,
		UIMenuFill,
		UIMenuForeground,
		UIMenuSelectedFill,
		UIMenuSelectedForeground,
		UIFieldBackground,
		UIFieldText,
		UIFieldTextLines,
		UIFieldCaret,
		UIFieldTextHighlightBackground,
		UIFieldTextHighlightForeground,
		UIFieldFepRawText,
		UIFieldFepRawBackground,
		UIFieldFepConvertedText,
		UIFieldFepConvertedBackground,
		UIFieldFepUnderline,
		UIFormFrame,
		UIFormFill,
		UIDialogFrame,
		UIDialogFill,
		UIAlertFrame,
		UIAlertFill,
		UIOK,
		UICaution,
		UIWarning,
		UILastColorTableEntry
		} UIColorTableEntries;*/
		
		
		UIColorSetTableEntry(UIObjectFrame, &Green);
		UIColorSetTableEntry(UIObjectFill, &Black);
		UIColorSetTableEntry(UIObjectForeground, &Green);
		UIColorSetTableEntry(UIObjectSelectedFill, &Green);
		UIColorSetTableEntry(UIObjectSelectedForeground, &Black);
		UIColorSetTableEntry(UIMenuFrame, &Green);
		UIColorSetTableEntry(UIMenuFill, &Black);
		UIColorSetTableEntry(UIMenuForeground, &Green);
		UIColorSetTableEntry(UIMenuSelectedFill, &Green);
		UIColorSetTableEntry(UIMenuSelectedForeground, &Black);
		UIColorSetTableEntry(UIFieldBackground, &Black);
		UIColorSetTableEntry(UIFieldText, &Green);
		UIColorSetTableEntry(UIFieldTextLines, &Green);
		UIColorSetTableEntry(UIFieldCaret, &Green);
		//UIColorSetTableEntry(UIFieldTextHighlightBackground, &InvertPurpleRGB);
		//UIColorSetTableEntry(UIFieldTextHighlightForeground, &InvertLtPurple);
		UIColorSetTableEntry(UIFieldFepRawText, &Green);
		UIColorSetTableEntry(UIFieldFepRawBackground, &Black);
		UIColorSetTableEntry(UIFieldFepConvertedText, &Green);
		UIColorSetTableEntry(UIFieldFepConvertedBackground, &Black);
		UIColorSetTableEntry(UIFieldFepUnderline, &Green);
		UIColorSetTableEntry(UIFormFrame, &Green);
		UIColorSetTableEntry(UIFormFill, &Black);
		UIColorSetTableEntry(UIDialogFrame, &Green);
		UIColorSetTableEntry(UIDialogFill, &Black);
		UIColorSetTableEntry(UIAlertFrame, &Green);
		UIColorSetTableEntry(UIAlertFill, &Black);
		UIColorSetTableEntry(UIOK, &Green);
		UIColorSetTableEntry(UICaution, &Green);
		UIColorSetTableEntry(UIWarning, &Green);

}

static void endDrawOffscreen() 
{
	WinSetDrawWindow(oldDrawWinH);
}
void flipDisplay();
void flipDisplay() 
{
	WinCopyRectangle(OffScreenH,oldDrawWinH,&ScreenRect,0,0,winPaint);
} 
void startDrawOffscreen();
void startDrawOffscreen() 
{
  oldDrawWinH = WinSetDrawWindow(OffScreenH);
}


static void createScreenBuffer() {
  Err error;
  UInt32 new_cdepth = 16;
   Coord	drawAreaHeightCoords, drawAreaWidthCoords;

  WinScreenMode(winScreenModeSet,NULL,NULL,&new_cdepth,NULL);

  oldDrawWinH = WinGetDrawWindow();



  WinGetDisplayExtent( &drawAreaWidthCoords, &drawAreaHeightCoords );

	screen_width=drawAreaWidthCoords;
	screen_height=drawAreaHeightCoords;


  if (OffScreenH)
  	WinDeleteWindow(OffScreenH,true);
  	
  OffScreenH = WinCreateOffscreenWindow
    (screen_width, screen_height, nativeFormat, &error);
  ScreenRect.topLeft.x = ScreenRect.topLeft.y = 0;
  ScreenRect.extent.x = screen_width;
  ScreenRect.extent.y = screen_height;
  oldDrawWinH = WinGetDrawWindow();
  WinSetDrawWindow(OffScreenH);
  WinEraseRectangle(&ScreenRect, 0);
  WinSetDrawWindow(oldDrawWinH);
  screenBufferP=(unsigned char *)BmpGetBits(WinGetBitmap(OffScreenH));

}

/***********************************************************************
 *
 * FUNCTION:    	OnSearchString
 *
 * DESCRIPTION: 	Adds a character to search field, looks up the 
 *						string in the database and selects the item that matches.
 *
 * PARAMETERS:  	event - EventPtr containing character to add to search field
 *                      
 * RETURNED:    	true if the field handled the event
 *
 * REVISION HISTORY:
 *				Name		Date				Description
 *				----		----				-----------
 *				Julie		2000-10-02		Initial Revision
 *
 ***********************************************************************/
static Boolean OnSearchString (EventPtr event)
{
   FormPtr frmP = FrmGetActiveForm();
   UInt fldIndex = FrmGetObjectIndex(frmP, MainSearchField);
   FieldPtr fldP = (FieldPtr)FrmGetObjectPtr (frmP, fldIndex);
   TablePtr tableP = (TablePtr)GetObjectPtr (MainTable);
	CharPtr fldTextP;
   int i = 0;
   int countNum = 0;
   char Temp[51],Temp2[51]; 
	
	// Get the table and it's number of rows
	
   FrmSetFocus(frmP, fldIndex);
  
   if (FldHandleEvent (fldP, event) || event->eType == fldChangedEvent || event->eType == ctlSelectEvent)
   {
      // get edit field pointer
      fldTextP = FldGetTextPtr(fldP);
      
      if (fldTextP == NULL)
      		return false;
      
      // if no search letter, set default value
      if (fldTextP[0] == '\0')
      {
      	StrCopy(Searchcnd, "");
 			// clear alphabet push button
      }
	  	else
	  		// get the search string
			SafeStrCopy(Searchcnd, fldTextP,10,__FILE__,__LINE__);

    TopVisibleRow = 0;
    StrToLower(Temp2,Searchcnd);

	for (i=0;i<TotalFoundGames;i++)
	{
		if(DriverFound)
		{		
			StrToLower(Temp,DriverFound[i].driverLongName);
			if (!StrNCompare(Temp ,Temp2,StrLen(Temp2)))
			{
				if (i > (TotalFoundGames-RowsInTable))
					i=TotalFoundGames-RowsInTable;
				TopVisibleRow = i;
				break;
			}
		}
	}

		// redraw table
		TblEraseTable(tableP);
	   TblDrawTable(tableP);  
	   DrawRatings();
		return true;
   }

   // Event not handled
   return false;
}

int CountROMFiles()
{
	int CountROMS;
	
	CountROMS = GetDirCount("PalmMAME/roms/");
	
	if (FileList)
	{
		MemPtrFree(FileList);
		FileList = NULL;
	}
	FileList = (char *)MemGluePtrNew(CountROMS*sizeof(char)*15);
	MemSet(FileList,CountROMS*sizeof(char)*15,0);

	return CountROMS;

}

void CheckForROMFiles()
{
	int count;
	char 		FileName[30];
	int			Exists=0;
	int 		CountROMS;
	int count2;
	char *p;
	TotalFoundGames = 0;
	CountROMS = GetDir("PalmMAME/roms/");

	for (count = 0; count < TotalGames; count++)
	{
#ifdef _TAPWAVEBUILD_
		if(FilterOn==FilterVector && !DriverList[count].vector)
			continue;
#else
		if (FilterOn == FilterAvailable)
		{
			Exists=0;
			//StrCopy(FileName,"roms/");
			StrCopy(FileName,DriverList[count].driverName);
			StrCat(FileName,".zip");
			//Exists = file_exists(FileName);
			for(count2=0;count2<CountROMS;++count2)
			{
				p=p=FileList;
	  			p=p+count2*15;
				if (StrNCaselessCompare(p,FileName,14) == 0)
				{
					Exists = 1;
					break;
				}
			}
			
			if (!Exists)
				continue;
		}
#endif
	
		DriverFound[TotalFoundGames].driverIndex=DriverList[count].driverIndex;
		DriverFound[TotalFoundGames].moduleIndex=DriverList[count].moduleIndex;
		StrCopy(DriverFound[TotalFoundGames].driverName,DriverList[count].driverName);
		StrCopy(DriverFound[TotalFoundGames].driverLongName,DriverList[count].driverLongName);
#ifdef _TAPWAVEBUILD_
		StrCopy(DriverFound[TotalFoundGames].manufacturer,DriverList[count].manufacturer);
		StrCopy(DriverFound[TotalFoundGames].year,DriverList[count].year);
		DriverFound[TotalFoundGames].vector=DriverList[count].vector;
#endif

		TotalFoundGames++;		
	}

	if(TotalFoundGames > 0)
		SysQSort(DriverFound,TotalFoundGames,sizeof(DriverFoundType),CompareFoundFunction,0);

}

#ifdef _TAPWAVEBUILD_
void SetModuleName(Int16 ModNum)
{
	if (ModNum == 0)
	{
		ModuleName = 'Mod0';
		StrCopy(FullModuleName,"ZMod0.prc");
	}
	else if (ModNum == 1)
	{
		ModuleName = 'Mod1';
		StrCopy(FullModuleName,"ZMod1.prc");
	}
	else if (ModNum == 2)
	{
		ModuleName = 'Mod2';
		StrCopy(FullModuleName,"ZMod2.prc");
	}
	else if (ModNum == 3)
	{
		ModuleName = 'Mod3';
		StrCopy(FullModuleName,"ZMod3.prc");
	}
	else if (ModNum == 4)
	{
		ModuleName = 'Mod4';
		StrCopy(FullModuleName,"ZMod4.prc");
	}
	else if (ModNum == 5)
	{
		ModuleName = 'Mod5';
		StrCopy(FullModuleName,"ZMod5.prc");
	}
	else if (ModNum == 6)
	{
		ModuleName = 'Mod6';
		StrCopy(FullModuleName,"ZMod6.prc");
	}
	else if (ModNum == 7)
	{
		ModuleName = 'Mod7';
		StrCopy(FullModuleName,"ZMod7.prc");
	}
	else if (ModNum == 8)
	{
		ModuleName = 'Mod8';
		StrCopy(FullModuleName,"ZMod8.prc");
	}
	else if (ModNum == 9)
	{
		ModuleName = 'Mod9';
		StrCopy(FullModuleName,"ZMod9.prc");
	}
	else if (ModNum == 10)
	{
		ModuleName = 'ModA';
		StrCopy(FullModuleName,"ZModA.prc");
	}
	else if (ModNum == 11)
	{
		ModuleName = 'ModB';
		StrCopy(FullModuleName,"ZModB.prc");
	}
}
#else
void SetModuleName(Int16 ModNum)
{
	if (ModNum == 0)
	{
		ModuleName = 'Mod0';
		StrCopy(FullModuleName,"PalmMAME/PMameMod0.prc");
	}
	else if (ModNum == 1)
	{
		ModuleName = 'Mod1';
		StrCopy(FullModuleName,"PalmMAME/PMameMod1.prc");
	}
	else if (ModNum == 2)
	{
		ModuleName = 'Mod2';
		StrCopy(FullModuleName,"PalmMAME/PMameMod2.prc");
	}
	else if (ModNum == 3)
	{
		ModuleName = 'Mod3';
		StrCopy(FullModuleName,"PalmMAME/PMameMod3.prc");
	}
	else if (ModNum == 4)
	{
		ModuleName = 'Mod4';
		StrCopy(FullModuleName,"PalmMAME/PMameMod4.prc");
	}
	else if (ModNum == 5)
	{
		ModuleName = 'Mod5';
		StrCopy(FullModuleName,"PalmMAME/PMameMod5.prc");
	}
	else if (ModNum == 6)
	{
		ModuleName = 'Mod6';
		StrCopy(FullModuleName,"PalmMAME/PMameMod6.prc");
	}
	else if (ModNum == 7)
	{
		ModuleName = 'Mod7';
		StrCopy(FullModuleName,"PalmMAME/PMameMod7.prc");
	}
	else if (ModNum == 8)
	{
		ModuleName = 'Mod8';
		StrCopy(FullModuleName,"PalmMAME/PMameMod8.prc");
	}
	else if (ModNum == 9)
	{
		ModuleName = 'Mod9';
		StrCopy(FullModuleName,"PalmMAME/PMameMod9.prc");
	}
	else if (ModNum == 10)
	{
		ModuleName = 'ModA';
		StrCopy(FullModuleName,"PalmMAME/PMameModA.prc");
	}
	else if (ModNum == 11)
	{
		ModuleName = 'ModB';
		StrCopy(FullModuleName,"PalmMAME/PalmMESS.prc");
	}
}
#endif

#define FLUSH_D_CACHE {int i,j;UInt8 *tmpPtr;\
		tmpPtr=MemPtrNew(32768);j=0;\
		for (i=0;i<32768;i++) j+=(int)tmpPtr[i];\
		MemPtrFree(tmpPtr);tmpPtr=MemPtrNew(32768);\
		j=0;for (i=0;i<32768;i++) j+=(int)tmpPtr[i];\
		MemPtrFree(tmpPtr);\
	}

static void MameCallPno()
{
	UInt32 processor;
	UInt32 result;
	UInt32 glue;
    UInt32 featureValue;
	UInt16 timeout;
	//hw_set_fullscreen(1);
		
	// call the PACE Native Object
	FtrGet(sysFtrCreator, sysFtrNumProcessorID, &processor);

	if (sysFtrNumProcessorIsARM(processor))
	{
		PnoDescriptor pno;
		//Err err;
		MemPtr pnoPtr = (MemPtr)GetThePNOSD(FullModuleName);

		//err = PnoLoadFromResources(&pno, 'ARMC', 1, 'PDac', 1);
		
		if (!pnoPtr)
			//SysFatalAlert("failed to load pno");
			return;

		ljp_PnoLoad(&pno, pnoPtr,wholesize);
		//FtrPtrFree('PDac',1);
		
		
		{
			UInt32 i,j;
			UInt8 *tmpPtr;
			tmpPtr=MemPtrNew(32768);
			j=0;
			for (i=0;i<32768;i++)
			{
				j+=(int)tmpPtr[i];
			}
			MemPtrFree(tmpPtr);
			tmpPtr=MemPtrNew(32768);
			j=0;
			for (i=0;i<32768;i++)
			{
				j+=(int)tmpPtr[i];
			}
			MemPtrFree(tmpPtr);
		}
		timeout = SysSetAutoOffTime(0);
		
		if((Boolean) (FtrGet(twFtrCreator, twFtrAPIVersion, &featureValue) == errNone))
		{
			FtrGet(twFtrCreator, twFtrAPIGlue, &glue);
			result = ljp_PnoCall(&pno, (void *)glue);
		}
		else
			result = ljp_PnoCall(&pno, 0);
		ljp_PnoUnload(&pno);
		
		SysSetAutoOffTime(timeout);
	}

}

static void MamePlayGameSD(Int16 GameNum, UInt8 Module)
{

    UInt16	count1=0;
    UInt16	CountDrivers = 0;
    Err error=0;
    //LocalID theDBID;
	//UInt theCardNo;
	UInt16 tempnum;
	UInt8 iCPUSpeed,iAudioSpeed;
	UInt32	SoundOption = 0;
	UInt32	RotateOption = 0;
	UInt8   ScaleOption = 0;
	UInt8	ScaleFlag=0;
	UInt8	MenuOption=0;
UInt32 g_bt_gamepadused=0;
UInt32 g_bt_gamepadclosed=0;
UInt32 g_n_serportid=0;
UInt32 g_ir_keyboardused=0;
Boolean bSerPortOpened = false;
UInt16 nSerPortId = 0;
char *ptr;
	
	//DmSearchStateType theSearchState;

	GameIndex = ByteSwap16(GameNum);
	
	SetModuleName(Module);
	
	if (SelectedRom == -1)
		GetGameConfigFile(1);
	else
		GetGameConfigFile(0);

	SoundOption = ByteSwap32(GameOption.SoundOption);
	RotateOption = ByteSwap32(GameOption.RotateOption);
	ScaleFlag = GameOption.ScaleOption;
	

	iCPUSpeed = GameOption.iCPUSpeed;
	iAudioSpeed =GameOption.iAudioSpeed;
	
	if (!iCPUSpeed) iCPUSpeed = 100;
	if (!iAudioSpeed) iAudioSpeed = 100;
	
	
	for (count1 = 0;count1<15;count1++)
	{
		KeyStruct[count1].Key = ByteSwap32(KeyStruct[count1].Key);
	
	}


	//Set flag to say we're running mame for the Splash screen	
	tempnum = 1;
	PrefSetAppPreferences (appFileCreator, AppRanMame, appPrefVersionNum, 
		&tempnum, sizeof (UInt16), true);
	
	//Set the sound option
	PrefSetAppPreferences (appFileCreator, AppSoundOption, appPrefVersionNum, 
		&SoundOption, sizeof (UInt32), true);

	//Set the rotate option
	PrefSetAppPreferences (appFileCreator, AppRotateOption, appPrefVersionNum, 
		&RotateOption, sizeof (UInt32), true);

	//Set the scale option
	PrefSetAppPreferences (appFileCreator, AppScale, appPrefVersionNum, 
		&ScaleFlag, sizeof (UInt8), true);

	//Set the Keys option
	PrefSetAppPreferences (appFileCreator, AppKeyOption, appPrefVersionNum, 
		&KeyStruct, sizeof (KeyStruct), true);

	//Set the game index to run
	PrefSetAppPreferences (appFileCreator, AppRunGameIndex, appPrefVersionNum, 
		&GameIndex, sizeof (Int16), true);
		
	//Set the menu option
	PrefSetAppPreferences (appFileCreator, AppMenuOption, appPrefVersionNum, 
		&GameOption.MenuOption, sizeof (UInt8), true);

	//Set the CPU speed option
	PrefSetAppPreferences (appFileCreator, AppCPUSpeed, appPrefVersionNum, 
		&iCPUSpeed, sizeof (UInt8), true);

	//Set the Audio CPU speed option
	PrefSetAppPreferences (appFileCreator, AppAudioSpeed, appPrefVersionNum, 
		&iAudioSpeed, sizeof (UInt8), true);


	GDrawBmp(0,0,LoadingRoms);

	//Copy module from card to memory
	//error = ImportVFS_To_SD(&theCardNo, &theDBID, FullModuleName);

	// Grab the id of the application we want to launch (the memo pad)
	//error = DmGetNextDatabaseByTypeCreator(true, &theSearchState, ModuleName, appFileCreator, true, &theCardNo, &theDBID);
	
	// Launch the new app.
	/*if (!error)
	{
		SysUIAppSwitch(theCardNo, theDBID, sysAppLaunchCmdNormalLaunch, NULL);
		
	}*/
	displayFtrP =(UInt32)hw_query_vram();
	FtrSet('PDac',1111,(unsigned long)displayFtrP);
	
	if (g_InputDeviceUsed)
	{
		error = SrmOpen(serPortIrPort, 9600, &nSerPortId);
			if ((error == errNone) || (error == serErrAlreadyOpen))
				bSerPortOpened = true;
			else
				//DEBUGS("Couldn't open IR port.");
				FrmCustomAlert(10024,"Couldn't open IR port.","","");

			SrmControl(nSerPortId, srmCtlIrDAEnable, NULL, NULL);
			SrmControl(nSerPortId, srmCtlRxEnable, NULL, NULL);
	}
	
	if (!bSerPortOpened)
		g_InputDeviceUsed=0;
		
	FtrSet(appFileCreator, FTR_OPT_IRKB_USED_ID, (g_InputDeviceUsed));
	FtrSet(appFileCreator, FTR_OPT_BTGP_USED_ID, ((g_InputDeviceUsed==9) && bSerPortOpened));
	FtrSet(appFileCreator, FTR_OPT_BTGP_CLOSED_ID, g_bt_gamepadclosed);
	FtrSet(appFileCreator, FTR_OPT_SERIAL_PORTID_ID, nSerPortId);


	//FtrPtrNew(appFileCreator, FTR_OPT_INPUTCONF_TREO_ID, 20*4*3, (void**)&ptr);
	//DmWrite(ptr, 0, (void*)&(g_inputconf_treo[g_rom_system][0][0]), 20*4*3);
		
	//FtrPtrNew(appFileCreator, FTR_OPT_IRKB_CONFIG_ID, 128, (void**)&ptr);
	//DmWrite(ptr, 0, (void*)&(g_IRKeyBoardConf[0][0]), 128);

	MameCallPno();
	
	if (bSerPortOpened)
		SrmClose(nSerPortId);
	bSerPortOpened = false;
	nSerPortId = 0;

}
static void MESSPlayGame()
{
    UInt16	count1=0;
    UInt16	CountDrivers = 0;
    Err error=0;
    //LocalID theDBID;
	//UInt theCardNo;
	UInt16 tempnum;
	//DmSearchStateType theSearchState;
	UInt32	SoundOption = 0;
	UInt32	RotateOption = 0;
	UInt8   ScaleOption = 0;
	UInt8	ScaleFlag=0;
	UInt8	MenuOption=0;
	UInt16 nSerPortId = 0;
	GameIndex = ByteSwap16(0);

	SetModuleName(11);

	//GetGameConfigFile(1);

	SoundOption = ByteSwap32(GameOption.SoundOption);
	RotateOption = ByteSwap32(GameOption.RotateOption);
	ScaleFlag = GameOption.ScaleOption;
	
	for (count1 = 0;count1<15;count1++)
	{
		KeyStruct[count1].Key = ByteSwap32(KeyStruct[count1].Key);
	
	}


	//Set flag to say we're running mame for the Splash screen	
	tempnum = 1;
	PrefSetAppPreferences (appFileCreator, AppRanMame, appPrefVersionNum, 
		&tempnum, sizeof (UInt16), true);
	
	//Set the sound option
	PrefSetAppPreferences (appFileCreator, AppSoundOption, appPrefVersionNum, 
		&SoundOption, sizeof (UInt32), true);

	//Set the rotate option
	PrefSetAppPreferences (appFileCreator, AppRotateOption, appPrefVersionNum, 
		&RotateOption, sizeof (UInt32), true);

	//Set the scale option
	PrefSetAppPreferences (appFileCreator, AppScale, appPrefVersionNum, 
		&ScaleFlag, sizeof (UInt8), true);

	//Set the Keys option
	PrefSetAppPreferences (appFileCreator, AppKeyOption, appPrefVersionNum, 
		&KeyStruct, sizeof (KeyStruct), true);

	//Set the game index to run
	PrefSetAppPreferences (appFileCreator, AppRunGameIndex, appPrefVersionNum, 
		&GameIndex, sizeof (Int16), true);
		
	//Set the menu option
	PrefSetAppPreferences (appFileCreator, AppMenuOption, appPrefVersionNum, 
		&GameOption.MenuOption, sizeof (UInt8), true);

	//Set the menu option
	PrefSetAppPreferences (appFileCreator, AppMESSCommandLine, appPrefVersionNum, 
		&MESSCommandLine,  256, true);


	GDrawBmp(0,0,LoadingRoms);

	/*
	//Copy module from card to memory
	error = ImportVFS_To_SD(&theCardNo, &theDBID, FullModuleName);

	// Grab the id of the application we want to launch (the memo pad)
	error = DmGetNextDatabaseByTypeCreator(true, &theSearchState, ModuleName, appFileCreator, true, &theCardNo, &theDBID);
	
	// Launch the new app.
	if (!error)
	{
		SysUIAppSwitch(theCardNo, theDBID, sysAppLaunchCmdNormalLaunch, NULL);
		
	}*/
	displayFtrP =(UInt32)hw_query_vram();
	FtrSet('PDac',1111,(unsigned long)displayFtrP);
	MameCallPno();

}

Int16 CompareFunction (void *p1, void *p2, Int32 other)
{
	DriverListType *Driver1,*Driver2;
	
	Driver1 = p1;
	Driver2 = p2;

	return StrCompare(Driver1->driverLongName,Driver2->driverLongName);

}
Int16 CompareFoundFunction (void *p1, void *p2, Int32 other)
{
	DriverFoundType *Driver1,*Driver2;
	
	Driver1 = p1;
	Driver2 = p2;
	
	return StrCompare(Driver1->driverLongName,Driver2->driverLongName);

}
/***********************************************************************
 *
 * FUNCTION:    PushBOff
 *
 * DESCRIPTION: This function will turn off a push button 
 *				    
 *
 * PARAMETERS:  frmP form pointer, idPushB PushButtonID
 *					
 *
 * RETURNED:    Nothing
 *					 
 *
 * REVISION HISTORY:
 *
 *			Name		Date				Description
 *			----		----				-----------
 *			 AK		06 28 2001				Initial creation
 * 
 ***********************************************************************/
void PushBOff(FormPtr frmP, Word PushButtonID)
{
		ControlPtr ContP;
		
		ContP = (ControlPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP,PushButtonID));
		CtlSetValue (ContP, 0);
}

/***********************************************************************
 *
 * FUNCTION:    PushBOn
 *
 * DESCRIPTION: This function will turn on a push button 
 *				    
 *
 * PARAMETERS:  frmP form pointer, idPushB PushButtonID
 *					
 *
 * RETURNED:    Nothing
 *					 
 *
 * REVISION HISTORY:
 *
 *			Name		Date				Description
 *			----		----				-----------
 *			 AK		06 28 2001				Initial creation
 * 
 ***********************************************************************/
void PushBOn(FormPtr frmP, Word PushButtonID)
{
		ControlPtr ContP;
		
		ContP = (ControlPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP,PushButtonID));
		CtlSetValue (ContP, 1);
}

/*
 * FUNCTION: MainFormInit
 *
 * DESCRIPTION: This routine initializes the MainForm form.
 *
 * PARAMETERS:
 *
 * frm
 *     pointer to the MainForm form.
 */

static void MainFormInit(FormType *frmP)
{
   	TablePtr			tableP;
    UInt16 	prefsSize;
    Int16 	version;
    UInt16	tempnum;
	
	//Used for Rom Listing
#ifdef LISTROMS
	int count = 0;
	char Temp[256];
	char Temp2[256];
#endif


	TopVisibleRow = 0;

	prefsSize = sizeof(TopVisibleRow);
	version = PrefGetAppPreferences(appFileCreator, AppTopRow, &TopVisibleRow, &prefsSize, true);
	if (version == noPreferenceFound || prefsSize !=  sizeof(TopVisibleRow))
		TopVisibleRow = 0;

	/*GetGameConfigFile(1);//1 for default config

	prefsSize = sizeof(UInt8);
	version = PrefGetAppPreferences(appFileCreator, AppCPUSpeed, &iCPUSpeed, &prefsSize, true);
	if (version == noPreferenceFound || prefsSize !=  sizeof(UInt8))
		iCPUSpeed = 100;
		
	StrCopy(strCPUSpeed,StrIToA(Temp3,iCPUSpeed));
	CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,CPUSpeed) ),strCPUSpeed);


	prefsSize = sizeof(UInt8);
	version = PrefGetAppPreferences(appFileCreator, AppAudioSpeed, &iAudioSpeed, &prefsSize, true);
	if (version == noPreferenceFound || prefsSize !=  sizeof(UInt8))
		iAudioSpeed = 100;
		
	StrCopy(strAudioSpeed,StrIToA(Temp3,iAudioSpeed));
	CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,AudioSpeed) ),strAudioSpeed);
	*/
	version = PrefGetAppPreferences(appFileCreator, AppFilter, &FilterOn, &prefsSize, true);
	if (version == noPreferenceFound || prefsSize !=  sizeof(FilterOn))
		FilterOn = 0;
		
	tempnum = 0;
	PrefSetAppPreferences (appFileCreator, AppRanMame, appPrefVersionNum, 
		&tempnum, sizeof (UInt16), true);


	//Load Sound Options
	/*prefsSize = sizeof(UInt32);
	version = PrefGetAppPreferences(appFileCreator, AppSoundOption, &SoundOption, &prefsSize, true);
	if (version == noPreferenceFound || prefsSize != sizeof(UInt32))
	{
		//Not Found
		SoundOption = 0;
		
	}
	else
		SoundOption = ByteSwap32(SoundOption);*/
		
	tableP = (TablePtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, MainTable));
	RowsInTable = TblGetNumberOfRows(tableP);

	// get number of record that is to display on the form
	StrCopy(Searchcnd,"");	//AK - now we retrieve it from prefs
	SetFieldString(Searchcnd);
	
	if (DriverFound)
		MemPtrFree(DriverFound);
	DriverFound = (DriverFoundType *)MemGluePtrNew(sizeof(DriverFoundType) * TotalGames);
	MemSet(DriverFound,sizeof(DriverFoundType) * TotalGames,0);
	
	//Make sure Top is not higher than number of games	
	if(TopVisibleRow >= TotalGames)
		TotalGames = 0;
	
	//Load the ROM list into the found list
	CheckForROMFiles();
			
	// Load the records into the table
	MainViewLoadRecords(frmP);

	// Draw the form.
	TblEraseTable(tableP);
	TblDrawTable(tableP);
	
	//Set Sound Option
	/*if (SoundOption == 0)
		PushBOn(frmP,SoundOffPushButton);
	else if (SoundOption == 11025)
		PushBOn(frmP,SoundLowPushButton);
	else if (SoundOption == 44100)
		PushBOn(frmP,SoundHighPushButton);
		
	//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
	list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotateList) );
	LstSetSelection(list,RotateOption);
	CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

	//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
	list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,StatBarList) );
	LstSetSelection(list,MenuOption);
	CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,StatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
	
	if (ScaleFlag)
		PushBOn(frmP,MainScaleCheckbox);
	else
		PushBOff(frmP,MainScaleCheckbox);
	ScaleOption = ScaleFlag;*/
		
	FrmDrawForm(frmP);
		
#ifdef LISTROMS
	// Rom Textfile output
	for ( count = 0; count < TotalGames;count++)
	{
		StrCopy(Temp,(StrIToA(Temp2,DriverList[count].moduleIndex)));
		StrCat(Temp, ",");
		StrCat(Temp,DriverList[count].driverName);
		StrCat(Temp, ",");
		StrCat(Temp,DriverList[count].driverLongName);
		debugs(Temp);

	}
#endif
}


static void MainViewLoadTable (FormPtr frm, UInt recordNum)
{
	Word			row;
	Word			numRows;
	TablePtr 	tableP;
	
	// Get the History table's pointer
	tableP = (TablePtr)GetObjectPtr (MainTable);
	
	// For each row in the table, store the record number in the 
	// table item that will display the record.  
	numRows = TblGetNumberOfRows (tableP);
    
	for (row = 0; row < numRows; row ++)
	{		
		ControlPtr ConBtn;
      	ConBtn = (ControlPtr)GetObjectPtr (Config1 + row);

      	if ( row + TopVisibleRow < TotalFoundGames )
		{
			// Set History table item to indicate that we want to be called
			// to draw the record.  The callback set in HistoryViewLoadRecords
			// will be called to draw the record.
			TblSetItemStyle (tableP, row, 0, customTableItem);
			TblSetRowUsable (tableP, row, true);
			
			// enable config button
			CtlShowControl(ConBtn);

		}
    	else
		{
			// Sometimes there are more table rows than records.
			// If this happens mark those unused table rows as not usable.
			TblSetRowUsable (tableP, row, false);
			// if the record is less then number of rows in table, 
			// get config button's pointer and hide the button.
			
         	CtlHideControl(ConBtn);

		}

		// Mark the row invalid so that it will draw when we call the 
		// draw routine.
		TblMarkRowInvalid (tableP, row);
	}
	
	MainUpdateScrollers(frm);
}


static void MainViewLoadRecords(FormPtr frm)
{
	TablePtr 		 tableP;
	
	// Get the table and it's number of rows
	tableP =(TablePtr) GetObjectPtr (MainTable);
	RowsInTable = TblGetNumberOfRows (tableP);
	
	// Now that the table is in position load the records.
	MainViewLoadTable (frm, TotalFoundGames);

	// Set the callback routine that will draw the records.
	TblSetCustomDrawProcedure (tableP, 0, MainViewDrawRecord);

	// Set the column usable so that it draws and accepts user input.
	TblSetColumnUsable (tableP, 0, true);	
}


static void MainViewDrawRecord(VoidPtr tableP, SWord row, SWord column, 
	RectanglePtr bounds)
{
	CharPtr		recText;
	Int			textLen, width;
	Boolean		fits;
	FontID 		currFont;
	char 		FileName[60];
	char 		FileName2[60];
	int			Exists=0;
	int			ExistsCfg=0;


	if (!DriverFound)
		return;

	currFont = FntSetFont (stdFont);

	if ( column == 0 )
	{
		recText = DriverFound[TopVisibleRow + row].driverLongName;
		StrCopy(FileName,"PalmMAME/roms/");
		StrCat(FileName,DriverFound[TopVisibleRow + row].driverName);
		StrCat(FileName,".zip");
		Exists = file_exists(FileName);

		if (!Exists)
		{	
			StrCopy(FileName2,"ZodMAME/roms/");
			StrCat(FileName2,DriverFound[TopVisibleRow + row].driverName);
			StrCat(FileName2,".zip");
			Exists = file_exists(FileName2);
		}

	}
			
   
	// Determine the length of text that will fit within the bounds.
	width = bounds->extent.x - 2;
	textLen = StrLen(recText);
	FntCharsInWidth(recText, &width, &textLen, &fits);
	
   	// Erase the old text in the table.
   	WinEraseRectangle(bounds,0);
	WinPushDrawState();
	if (Exists)
	{	
    	WinSetTextColor(colorMagicMint);
		//IndexedColorType icolor = 1;
    	//WinSetBackColor(icolor);
    }
	else
	{	
		IndexedColorType tcolor = colorBlack;
    	WinSetTextColor(colorLipstick);
		//IndexedColorType icolor = 1;
    	//WinSetBackColor(icolor);
    }

	WinDrawChars(recText, textLen, bounds->topLeft.x, bounds->topLeft.y);
	// Returns the draw state to original colours.
	WinPopDrawState();
	// Restore the font.
	FntSetFont (currFont);
}
/***********************************************************************
 *
 * FUNCTION:    MainScroll
 *
 * DESCRIPTION: This routine scrolls the list of editable fields
 *              in the direction specified.
 *
 * PARAMETERS:  direction - up or dowm
 *              oneLine   - if true the list is scroll by a single line,
 *                          if false the list is scroll by a full screen.
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void MainScroll (WinDirectionType direction)
{
   
   TablePtr  		table;
   FontID    		curFont;
   FormPtr 			frm;
   Word				numRows;

   
   frm = FrmGetActiveForm();

   curFont = FntSetFont (stdFont);
   table = (TablePtr)GetObjectPtr (MainTable);
   TblReleaseFocus (table);

	numRows = TblGetNumberOfRows (table);
  
   // Get the height of the table and the width of data column.
    						//2001 05 31 AK Scroll down only if there are records down there.
   if ((direction == winDown) && (TotalFoundGames > numRows))	{	// Scroll the table down.
      	if (TopVisibleRow < (TotalFoundGames - numRows*2)) 
            TopVisibleRow +=numRows;
   		else
   		    TopVisibleRow = TotalFoundGames - numRows;		
   }
   else  { // Scroll the table up.
     	if (TopVisibleRow >= numRows) 
        	 TopVisibleRow -=numRows;
         else
             TopVisibleRow = 0;
   }

   TblMarkTableInvalid (table);
   TblUnhighlightSelection (table);		
   // set position of scrollbar
   		
   MainUpdateScrollers(frm);
   	
   FrmDrawForm(frm);
	DrawRatings();


exit:   
   FntSetFont (curFont);
}
/***********************************************************************
 *
 * FUNCTION:    MainUpdateScrollers
 *
 * DESCRIPTION: This routine draws or erases the edit view scroll arrow
 *              buttons.
 *
 * PARAMETERS:  frm             -  pointer to the patient detail form
 *              bottomField     -  field index of the last visible row
 *              lastItemClipped -  true if the last visible row is clip at 
 *                                 the bottom
 *
 * RETURNED:    nothing
 *
 ***********************************************************************/
static void MainUpdateScrollers (FormPtr frm)
{
   Word upIndex;
   Word downIndex;
   Boolean scrollableUp;
   Boolean scrollableDown;
   Word		numRows;
   TablePtr  		table;

   table = (TablePtr)GetObjectPtr (MainTable);
	numRows = TblGetNumberOfRows (table);
   // If the first field displayed is not the fist field in the record,
   // enable the up scroller.
   scrollableUp = TopVisibleRow > 0;

   // If the last field displayed is not the last field in the record,
   // enable the down scroller.
   if (TopVisibleRow + numRows >= TotalFoundGames)
   	scrollableDown = false;
   else
   	scrollableDown = true;
   //scrollableDown = (lastItemClipped || (bottomFieldIndex < (RecordNum-1)));


   // Update the scroll button.
   upIndex = FrmGetObjectIndex (frm, MainUpButton);
   downIndex = FrmGetObjectIndex (frm, MainDownButton);
   FrmUpdateScrollers (frm, upIndex, downIndex, scrollableUp, scrollableDown);
}


/*
 * FUNCTION: MainFormDoCommand
 *
 * DESCRIPTION: This routine performs the menu command specified.
 *
 * PARAMETERS:
 *
 * command
 *     menu item id
 */

static Boolean MainFormDoCommand(UInt16 command)
{
	Boolean handled = false;

	switch (command)
	{
		case OptionsAboutPalmMameLoader:
		{
			FormType * frmP;

			/* Clear the menu status from the display */
			MenuEraseStatus(0);

			/* Display the About Box. */
			frmP = FrmInitForm (AboutForm);
			FrmDoDialog (frmP);                    
			FrmDeleteForm (frmP);

			handled = true;
			break;
		}
		case OptionsSearchforRomModules:
		{
			PrefSetAppPreferences(appFileCreator,AppLastModuleListed,appPrefVersionNum,NULL,0,true);
			PrefSetAppPreferences(appFileCreator, AppModuleSizePref, appPrefVersionNum,NULL, 0, true);
			PrefSetAppPreferences(appFileCreator, AppDriverList, appPrefVersionNum,NULL, 0, true);
			PrefSetAppPreferences(appFileCreator, AppRunGameIndex, appPrefVersionNum,NULL, 0, true);
			PrefSetAppPreferences(appFileCreator, AppLastModuleListed, appPrefVersionNum,NULL, 0, true);
			PrefSetAppPreferences(appFileCreator, AppTopRow, appPrefVersionNum,NULL, 0, true);
			PrefSetAppPreferences(appFileCreator, AppRanMame, appPrefVersionNum,NULL, 0, true);
			AppStart();
			FrmGotoForm(MainForm);
		
			handled = true;
			break;
		}
		case OptionsKeyConfig:
		{
			FrmGotoForm(ConfigForm);
			handled = true;
			break;
		}
		
		case OptionsMESS:
		{
			FrmGotoForm(MESSForm);
			handled = true;
			break;
		}
		
		case FilterShowAvailableROMS:
		{
			FormPtr frm;	
			TablePtr tableP = (TablePtr)GetObjectPtr (MainTable);

			FilterOn=FilterAvailable;
			PrefSetAppPreferences (appFileCreator, AppFilter, appPrefVersionNum, 
				&FilterOn, sizeof (Int8), true);
			CheckForROMFiles();
			TopVisibleRow=0;
			TblEraseTable(tableP);
			TblDrawTable(tableP);  
			frm = FrmGetActiveForm();
			FrmDrawForm(frm);
			MainUpdateScrollers(frm);			
		}
		break;
		
		case FilterShowAllROMS:
		{
			FormPtr frm;	
			TablePtr tableP = (TablePtr)GetObjectPtr (MainTable);

			FilterOn=FilterOff;
			PrefSetAppPreferences (appFileCreator, AppFilter, appPrefVersionNum, 
				&FilterOn, sizeof (Int8), true);
			CheckForROMFiles();
			TopVisibleRow=0;
			TblEraseTable(tableP);
			TblDrawTable(tableP);  
			frm = FrmGetActiveForm();
			FrmDrawForm(frm);
			MainUpdateScrollers(frm);
		}
		break;
		
	}

	return handled;
}
void GDrawBmp(int x, int y, int pic)
{
    GDrawbmp_handle = DmGetResource( bitmapRsc, pic );
    if( GDrawbmp_handle != NULL ) 
    {
		GDrawbmp = (BitmapType *)MemHandleLock( GDrawbmp_handle );
		if( GDrawbmp != NULL ) 
		{
		    WinDrawBitmap( GDrawbmp, x, y );
		}
		MemHandleUnlock( GDrawbmp_handle );
		DmReleaseResource( GDrawbmp_handle );
    }
}

static Boolean SplashFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	

	switch (eventP->eType) 
	{
		case frmOpenEvent:

			frmP = FrmGetActiveForm();
			
#ifdef _TAPWAVEBUILD_
			PINSetInputAreaState(pinInputAreaClosed);
			StatShow();
			PINSetInputTriggerState(pinInputTriggerDisabled);
			SysSetOrientationTriggerState(sysOrientationTriggerDisabled);

			SysSetOrientation(sysOrientationLandscape);
#endif

			FrmDrawForm(frmP);

  			//startDrawOffscreen();
			GDrawBmp(0,0,Splash);
			//endDrawOffscreen();
			//flipDisplay();
		break;
	
		case penDownEvent:
		case keyDownEvent:
			FrmGotoForm(MainForm);
			handled = true;
		break;
	}
	return handled;
}

static int FindChar(char *instring)
{
	int i;
	char *p=instring;
	
	for(i=0;i<StrLen(instring);i++)
	{
		if (*p == ':')
			return i+1;
		p++;
	
	}
	return 0;

}

static void UpdateKeys(UInt32 CurrentKey)
{
	FormType * frmP = FrmGetActiveForm();
	char *ListText;
	char NewText[30];
	int numchars;
	ListType *lst = (ListPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConfigButtonList ));
	int Selected = LstGetSelection(lst);
	char ButtonText[10];

	MemSet(NewText,30,0);
	MemSet(ButtonText,10,0);
	StrIToH(ButtonText,CurrentKey);
	ListText = LstGetSelectionText(lst,Selected);
	numchars = FindChar(ListText);
	StrNCopy(NewText,ListText,numchars);
	SafeStrCat(NewText,ButtonText,30,__FILE__,__LINE__);
	SafeStrCopy(ListText,NewText,30,__FILE__,__LINE__);

}
static void UpdateVirtualKeys(UInt8 VKey)
{
	FormType * frmP = FrmGetActiveForm();
	char *ListText;
	char NewText[25];
	int numchars;
	ListType *lst = (ListPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConfigButtonList ));
	int Selected = LstGetSelection(lst);
	char ButtonText[10];

	MemSet(NewText,25,0);
	MemSet(ButtonText,10,0);
	if (VKey == 1)
	{
		StrCopy(ButtonText,"VKey A");
	}
	else if (VKey == 2)
	{
		StrCopy(ButtonText,"VKey B");
	}
	else if (VKey == 3)
	{
		StrCopy(ButtonText,"VKey C");
	}
	else if (VKey == 4)
	{
		StrCopy(ButtonText,"VKey D");
	}
	else if (VKey == 5)
	{
		StrCopy(ButtonText,"VKey E");
	}
	ListText = LstGetSelectionText(lst,Selected);
	numchars = FindChar(ListText);
	StrNCopy(NewText,ListText,numchars);
	StrCat(NewText,ButtonText);
	SafeStrCopy(ListText,NewText,25,__FILE__,__LINE__);
	FrmDrawForm(frmP);

}
static void ClearListKeys()
{
	FormType * frmP = FrmGetActiveForm();
	char *ListText;
	char NewText[30];
	int numchars;
	ListType *lst = (ListPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConfigButtonList ));
	int Selected = LstGetSelection(lst);
	char ButtonText[10];

	MemSet(NewText,30,0);
	MemSet(ButtonText,10,0);
	
	StrIToH(ButtonText,KeyStruct[Selected].Key);
	ListText = LstGetSelectionText(lst,Selected);
	numchars = FindChar(ListText);
	StrNCopy(NewText,ListText,numchars);
	StrCat(NewText,ButtonText);
	SafeStrCopy(ListText,NewText,30,__FILE__,__LINE__);
	FrmDrawForm(frmP);

}
static void InitKeys()
{
	FormType * frmP = FrmGetActiveForm();
	char *ListText;
	char NewText[30];
	int numchars;
	ListType *lst = (ListPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConfigButtonList ));
	char ButtonText[10];
	int i=0;
	
	for (i=0;i<15;i++)
	{

		MemSet(NewText,30,0);
		MemSet(ButtonText,10,0);
		//if (KeyStruct[i].Key)
		//{
			StrIToH(ButtonText,KeyStruct[i].Key);
			ListText = LstGetSelectionText(lst,i);
			numchars = FindChar(ListText);
			StrNCopy(NewText,ListText,numchars);
			SafeStrCat(NewText,ButtonText,30,__FILE__,__LINE__);
			SafeStrCopy(ListText,NewText,30,__FILE__,__LINE__);
		//}
	}

}

static Boolean ConfigFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	ListType *lst = (ListPtr)FrmGetObjectPtr(frmP, FrmGetObjectIndex(frmP, ConfigButtonList ));
	ListType *list;

	switch (eventP->eType) 
	{
		case frmOpenEvent:

			frmP = FrmGetActiveForm();
			ConfigKeysP[0] = ConfigKeysText[0];
			ConfigKeysP[1] = ConfigKeysText[1];
			ConfigKeysP[2] = ConfigKeysText[2];
			ConfigKeysP[3] = ConfigKeysText[3];
			ConfigKeysP[4] = ConfigKeysText[4];
			ConfigKeysP[5] = ConfigKeysText[5];
			ConfigKeysP[6] = ConfigKeysText[6];
			ConfigKeysP[7] = ConfigKeysText[7];
			ConfigKeysP[8] = ConfigKeysText[8];
			ConfigKeysP[9] = ConfigKeysText[9];
			ConfigKeysP[10] = ConfigKeysText[10];
			ConfigKeysP[11] = ConfigKeysText[11];
			ConfigKeysP[12] = ConfigKeysText[12];
			ConfigKeysP[13] = ConfigKeysText[13];
			ConfigKeysP[14] = ConfigKeysText[14];
		
			LstSetListChoices(lst,ConfigKeysP,ConfigLast);
			InitKeys();
			
			//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,IRPopupList) );
			LstSetSelection(list,g_InputDeviceUsed);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,IRPopup) ),LstGetSelectionText(list,LstGetSelection(list)));


			FrmDrawForm(frmP);
		break;
		
		case frmCloseEvent:
		{
			int count1;
			for (count1 = 0;count1<15;count1++)
			{
				KeyStruct[count1].Key = ByteSwap32(KeyStruct[count1].Key);
			
			}

			//Set the Keys option
			PrefSetAppPreferences (appFileCreator, AppKeyOption, appPrefVersionNum, 
				&KeyStruct, sizeof (KeyStruct), true);
				
			for (count1 = 0;count1<15;count1++)
			{
				KeyStruct[count1].Key = ByteSwap32(KeyStruct[count1].Key);
			
			}

		}
	
		case ctlSelectEvent:
		{
			if (eventP->data.ctlSelect.controlID == ConfigBackButton)
			{
				FrmGotoForm(MainForm);;
				
			}
			else if (eventP->data.ctlSelect.controlID == ConfigKeyButton)
			{
				UInt32 CurrentKey = 0;
				int Selected = LstGetSelection(lst);
				EventType event;
				
				FrmShowObject(frmP,FrmGetObjectIndex(frmP,ConfigPressKey));
				
				
				KeySetMask(~keyBitsAll);
				while (!CurrentKey)
				{
					CurrentKey = KeyCurrentState();
				}
				while (KeyCurrentState());
				
				while (EvtEventAvail())
				{
					EvtGetEvent(&event,0);
				}
				
				
				UpdateKeys(CurrentKey);
				KeySetMask(keyBitsAll);
	       		KeyStruct[Selected].Key = CurrentKey;
	       		
				FrmHideObject(frmP,FrmGetObjectIndex(frmP,ConfigPressKey));
				FrmDrawForm(frmP);
				handled = true;
			}
			else if (eventP->data.ctlSelect.controlID == ConfigClearButton)
			{
				int Selected = LstGetSelection(lst);
				KeyStruct[Selected].Key = 0;
				ClearListKeys();		
			}
			


		}
		
		case popSelectEvent:
		{
            switch ( eventP->data.ctlSelect.controlID )
            {
                case IRPopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,IRPopupList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,IRPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					g_InputDeviceUsed = eventP->data.popSelect.selection;

                }
				break;
			}
		}
		
		case lstSelectEvent:
		{
		}
		break;
	}
	return handled;
}
/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */
	UInt32 heap=0;
	char strheap[20];

static Boolean MainFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	TablePtr tableP = (TablePtr)GetObjectPtr (MainTable);
	SWord rowNum, columnNum;
	UInt8 *scr=NULL;

	//Boolean needToRedraw;


	switch (eventP->eType) 
	{
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);
			
		case nilEvent:
			//heap = query_heap_free();
			//StrCopy(strheap,StrIToA(strheap,heap));
			//CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,MainFormMemoryLabel) ),strheap);
		
			break;


		case frmOpenEvent:
		{
			RectangleType rect;
			RctSetRectangle(&rect,20,20,120,30);
			
			frmP = FrmGetActiveForm();
			FrmDrawForm(frmP);

			WinEraseRectangle(&rect,0);
			WinDrawRectangleFrame(dialogFrame,&rect);
			WinDrawChars("Loading GameList",16,30,30);

			WinScreenLock(winLockCopy);
			heap = query_heap_free();
			StrCopy(strheap,StrIToA(strheap,heap));
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,MainFormMemoryLabel) ),strheap);

			SetAppColours();
			FrmDrawForm(frmP);

#ifdef _TAPWAVEBUILD_
			PINSetInputAreaState(pinInputAreaClosed);
			StatShow();
			PINSetInputTriggerState(pinInputTriggerEnabled);
			SysSetOrientationTriggerState(sysOrientationTriggerDisabled);
			SysSetOrientation(sysOrientationLandscape);
#endif

			MainFormInit(frmP);
			
			DrawRatings();
			WinScreenUnlock();

			handled = true;
		break;
		}
		
		case frmCloseEvent:
			/*if (DriverList)
			{
				MemPtrFree(DriverList);
				DriverList = NULL;
			}*/
			
			if (DriverFound)
			{
				MemPtrFree(DriverFound);
				DriverFound = NULL;
			}
			frmP = FrmGetActiveForm();
			FrmEraseForm(frmP);
			FrmDeleteForm(frmP);
			handled = true;
            break;
            
        case frmUpdateEvent:
			/* 
			 * To do any custom drawing here, first call
			 * FrmDrawForm(), then do your drawing, and
			 * then set handled to true. 
			 */
 			//frmP = FrmGetActiveForm();
			//FrmDrawForm(frmP);	  			

		break;
		
			
  		/*case winDisplayChangedEvent:

			frmP = FrmGetActiveForm();
			FrmDrawForm(frmP);

		break;*/

		case winEnterEvent:
			if (RomConfigReturn == 1)
			{
			 	frmP = FrmGetActiveForm();
			 	FrmDrawForm(frmP);
				DrawRatings();
				RomConfigReturn = 0;
			}
			break;

		case ctlSelectEvent:
		{
			
			if (eventP->data.ctlSelect.controlID >= Config1 && eventP->data.ctlSelect.controlID <= Config11)
			{
				SelectedRom = TopVisibleRow+eventP->data.ctlSelect.controlID-Config1;
				FrmPopupForm(RomConfigForm);
				break;
			}
			else if (eventP->data.ctlSelect.controlID == MainFormDefaultButton)
			{
				SelectedRom = -1;
				FrmPopupForm(RomConfigForm);
				break;
			}
			


			break;
		}

		
		case tblSelectEvent:
		{
			if (KeyStruct[3].Key == 0) //No up button defined
			{
				FrmAlert(KeyEmptyAlert);
			}
			else
			{
				int count1;
				
				
	    		// get selected row number
				TblGetSelection (tableP, &rowNum, &columnNum); 

				hw_set_fullscreen(1);
				
				{
					UInt32 			pinMgrVersion;
					Err err = FtrGet( pinCreator, pinFtrAPIVersion, &pinMgrVersion );
					if (!err && pinMgrVersion == pinAPIVersion1_1)
					{
						Coord         drawAreaHeightCoords, drawAreaWidthCoords;
						Int16         offsetCoordsX, offsetCoordsY;
						RectangleType formBounds;
						WinHandle     frmWinH;

						WinGetDisplayExtent( &drawAreaWidthCoords, &drawAreaHeightCoords );

						frmWinH = FrmGetWindowHandle(frmP);
						WinGetBounds(frmWinH, &formBounds);
					
						//for full screen windows topLeft.y is simply 0, or 1 for modal dialogs
						offsetCoordsX = drawAreaWidthCoords - formBounds.extent.x - formBounds.topLeft.x;
						offsetCoordsY = drawAreaHeightCoords - formBounds.extent.y - formBounds.topLeft.y;

						if (offsetCoordsX || offsetCoordsY)
						{
							formBounds.extent.x += offsetCoordsX;
							formBounds.extent.y += offsetCoordsY;

							// Change current draw window to match the display extent (app's drawing area)
							WinSetBounds( frmWinH, &formBounds );
						}
					}
				}
				
				//Save current position of rows displayed
				PrefSetAppPreferences (appFileCreator, AppTopRow, appPrefVersionNum, 
					&TopVisibleRow, sizeof (TopVisibleRow), true);
				
				SelectedRom = rowNum + TopVisibleRow;
				MamePlayGameSD(DriverFound[rowNum + TopVisibleRow].driverIndex, DriverFound[rowNum + TopVisibleRow].moduleIndex );

				EvtResetAutoOffTimer();

				//frmP = FrmGetActiveForm();
    			for (count1 = 0;count1<15;count1++)
				{
					KeyStruct[count1].Key = ByteSwap32(KeyStruct[count1].Key);
				}
				hw_set_fullscreen(0);
    			 //AK - This is needed to read the keys in again.
    						//	   If it isn't called then every OTHER game 
    						//	   launched will have the key config enian swapped
    			
    			screen_init();	//AK - This is to put the palm back in 16-bit mode
    			
    			SetAppColours(); //AK - After changing modes gotta set the colours
    			FrmGotoForm(MainForm);

    		}

			handled = true;
   		}
   		break;
		
	   case keyDownEvent:

         switch (eventP->data.keyDown.chr)
         	{
            case pageUpChr:
            case vchrRockerUp:
            case vchrActionUp:
               MainScroll (winUp);
               handled = true;
               break;
               
            case pageDownChr:
            case vchrRockerDown:
            case vchrActionDown:
               MainScroll (winDown);
               handled = true;
               break;
               
            default:
	         	OnSearchString(eventP);
	         	handled = true;
   	   		break;

           	}
         	
         break;
         
	    case ctlRepeatEvent:
         switch (eventP->data.ctlRepeat.controlID){
         
            case MainUpButton:
               MainScroll (winUp);
               // leave unhandled so the buttons can repeat
               break;
               
            case MainDownButton:
               MainScroll (winDown);
               // leave unhandled so the buttons can repeat
               break;
            default:
               break;
         }
         break;
	}
    
	return handled;
}
/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean MESSFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	UInt fldIndex = FrmGetObjectIndex(frmP, MessCLField);
	FieldPtr fldP = (FieldPtr)FrmGetObjectPtr (frmP, fldIndex);
	CharPtr fldTextP;
	char temp[257];
	ListType *list;


	switch (eventP->eType) 
	{
		case menuEvent:
			return MainFormDoCommand(eventP->data.menu.itemID);

		case frmOpenEvent:
			frmP = FrmGetActiveForm();
			if (!WinGetDrawWindow())
				WinSetDrawWindow(WinGetDisplayWindow());

			SetAppColours();
			//Set Sound Option
			if (GameOption.SoundOption == 0)
				PushBOn(frmP,MSoundOffPushButton);
			else if (GameOption.SoundOption == 11025)
				PushBOn(frmP,MSoundLowPushButton);
			else if (GameOption.SoundOption == 44100)
				PushBOn(frmP,MSoundHighPushButton);
				
			//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,MRotateList) );
			LstSetSelection(list,GameOption.RotateOption);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,MRotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

			//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,MStatBarList) );
			LstSetSelection(list,GameOption.MenuOption);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,MStatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
			
			if (GameOption.ScaleOption)
				PushBOn(frmP,MESSScaleCheckbox);
			else
				PushBOff(frmP,MESSScaleCheckbox);

					FrmDrawForm(frmP);
					handled = true;
				break;
            
			
		case ctlSelectEvent:
		{
			if (eventP->data.ctlSelect.controlID == MESSGo)
			{
			      // get edit field pointer
			      fldTextP = FldGetTextPtr(fldP);

			      if (fldTextP == NULL)
			      		break;
			      
			      // if empty don't call MESS
			      if (fldTextP[0] == '\0')
			      {
					break;
			      }
				  else
				  {
				  
						hw_set_fullscreen(1);
						{
							UInt32 			pinMgrVersion;
							Err err = FtrGet( pinCreator, pinFtrAPIVersion, &pinMgrVersion );
							if (!err && pinMgrVersion == pinAPIVersion1_1)
							{
								Coord         drawAreaHeightCoords, drawAreaWidthCoords;
								Int16         offsetCoordsX, offsetCoordsY;
								RectangleType formBounds;
								WinHandle     frmWinH;

								WinGetDisplayExtent( &drawAreaWidthCoords, &drawAreaHeightCoords );

								frmWinH = FrmGetWindowHandle(frmP);
								WinGetBounds(frmWinH, &formBounds);
							
								//for full screen windows topLeft.y is simply 0, or 1 for modal dialogs
								offsetCoordsX = drawAreaWidthCoords - formBounds.extent.x - formBounds.topLeft.x;
								offsetCoordsY = drawAreaHeightCoords - formBounds.extent.y - formBounds.topLeft.y;

								if (offsetCoordsX || offsetCoordsY)
								{
									formBounds.extent.x += offsetCoordsX;
									formBounds.extent.y += offsetCoordsY;

									// Change current draw window to match the display extent (app's drawing area)
									WinSetBounds( frmWinH, &formBounds );
								}
							}
						}
						
						
						
				  		// get the search string
						SafeStrCopy(temp, fldTextP,256,__FILE__,__LINE__);
						SafeStrCopy(MESSCommandLine, "mess ",256,__FILE__,__LINE__);
						SafeStrCat(MESSCommandLine, temp,256,__FILE__,__LINE__);
						MESSPlayGame();
						
						EvtResetAutoOffTimer();

						frmP = FrmGetActiveForm();
						SetAppColours();
		    			hw_set_fullscreen(0);
		    			
		    			AppStart();
		    			screen_init();
		    			SetAppColours();
		    			FrmGotoForm(MainForm);
				  }
			}
			else if(eventP->data.ctlSelect.controlID == a5200Button)
			{
				FldInsert(fldP, "a5200", 5);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == a7800Button)
			{
				FldInsert(fldP, "a7800", 5);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == colecoButton)
			{
				FldInsert(fldP, "coleco", 6);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == nesButton)
			{
				FldInsert(fldP, "nes", 3);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == cartButton)
			{
				FldInsert(fldP, " -cart", 6);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == flopButton)
			{
				FldInsert(fldP, " -flop", 6);
				handled = true;
			}
			else if (eventP->data.ctlSelect.controlID == MSoundOffPushButton)
			{
				GameOption.SoundOption = 0;
				
			}
			else if (eventP->data.ctlSelect.controlID == MSoundLowPushButton)
			{
				GameOption.SoundOption = 11025;
				
			}
			else if (eventP->data.ctlSelect.controlID == MSoundHighPushButton)
			{
				GameOption.SoundOption = 44100;
				
			}
			else if (eventP->data.ctlSelect.controlID == MESSScaleCheckbox)
			{
				GameOption.ScaleOption = CtlGetValue((ControlPtr)GetObjectPtr(MESSScaleCheckbox));
			}
			break;
		}

		case popSelectEvent:
		{
            switch ( eventP->data.ctlSelect.controlID )
            {
                case MRotatePopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotateList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					GameOption.RotateOption = eventP->data.popSelect.selection;

                }
				break;
				
				case MStatBarPopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,MStatBarList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,MStatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					GameOption.MenuOption = eventP->data.popSelect.selection;

                }
				break;
			}

		}

	}
    
	return handled;
}
/*
 * FUNCTION: MainFormHandleEvent
 *
 * DESCRIPTION:
 *
 * This routine is the event handler for the "MainForm" of this 
 * application.
 *
 * PARAMETERS:
 *
 * eventP
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed to
 *     FrmHandleEvent
 */

static Boolean ConfabulatorFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	UInt fldIndex = FrmGetObjectIndex(frmP, ConfabField);
	FieldPtr fldP = (FieldPtr)FrmGetObjectPtr (frmP, fldIndex);
	CharPtr fldTextP;


	switch (eventP->eType) 
	{

		case frmOpenEvent:
			FrmDrawForm(frmP);
			break;
			
			
		case ctlSelectEvent:
		{
			if (eventP->data.ctlSelect.controlID == ConfabDoneButton)
			{
			      // get edit field pointer
			      fldTextP = FldGetTextPtr(fldP);

			      if (fldTextP == NULL)
			      {
			      		StrCopy(ConfabReturnString,"100");
			      		FrmReturnToForm(0);
			      		handled = true;
			      		break;
			      }
			      		
			      
			      // if empty don't call MESS
			      if (fldTextP[0] == '\0')
			      {
						StrCopy(ConfabReturnString,"100");
			      		FrmReturnToForm(0);
			      		handled = true;
			      		break;
			      }
				  else
				  {
				  		// get the search string
						SafeStrCopy(ConfabReturnString, fldTextP,30,__FILE__,__LINE__);
			      		FrmReturnToForm(0);
			      		handled = true;
			      		break;
				  }
			}
			else if(eventP->data.ctlSelect.controlID == ConfabOneButton)
			{
				FldInsert(fldP, "1", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabTwoButton)
			{
				FldInsert(fldP, "2", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabThreeButton)
			{
				FldInsert(fldP, "3", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabFourButton)
			{
				FldInsert(fldP, "4", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabFiveButton)
			{
				FldInsert(fldP, "5", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabSixButton)
			{
				FldInsert(fldP, "6", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabSevenButton)
			{
				FldInsert(fldP, "7", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabEightButton)
			{
				FldInsert(fldP, "8", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabNineButton)
			{
				FldInsert(fldP, "9", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabZeroButton)
			{
				FldInsert(fldP, "0", 1);
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabCButton)
			{
				FldDelete(fldP, 0, FldGetTextLength(fldP));
				handled = true;
			}
			else if(eventP->data.ctlSelect.controlID == ConfabBackButton)
			{
				FldDelete(fldP, FldGetTextLength(fldP)-1, FldGetTextLength(fldP));
				handled = true;
			}
			break;
		}


	}
    
	return handled;
}

void DrawRatings()
{
	int row;
   Word		numRows;
   TablePtr  		table;
   char FileName[256];
   int ExistsCfg;
   
   if (!DriverFound)
   		return;

   table = (TablePtr)GetObjectPtr (MainTable);
	numRows = TblGetNumberOfRows (table);

	for (row=0;row<numRows;row++)
	{	
		StrCopy(FileName,"PalmMAME/ini/");
		StrCat(FileName,DriverFound[TopVisibleRow + row].driverName);
		StrCat(FileName,".ini");
		ExistsCfg = file_exists(FileName);
		
		if (ExistsCfg)
		{
			SelectedRom = TopVisibleRow + row;
			GetGameConfigFile(0);
			if (GameOption.Rating == 0)
				GDrawBmp(148,16+(row*11),Gold);
			else if (GameOption.Rating == 1)
				GDrawBmp(148,16+(row*11),Silver);
			else if (GameOption.Rating == 2)
				GDrawBmp(148,16+(row*11),Bronze);
			else if (GameOption.Rating == 3)
				GDrawBmp(148,16+(row*11),Stop);
			else if (GameOption.Rating == 4)
			{
				RectangleType rect;
				RctSetRectangle(&rect,148,16+(row*11),11,11);
				WinEraseRectangle(&rect,0);
			}
		}
		else
		{
				RectangleType rect;
				RctSetRectangle(&rect,148,16+(row*11),11,11);
				WinEraseRectangle(&rect,0);
		}	
	}
}

void GetGameConfigFile(int defaultFlag)
{
	FILE *fp=NULL;
	char FileName[256];
	int Exists;

	if (!defaultFlag)
	{
		StrCopy(FileName,"PalmMAME/ini/");
		StrCat(FileName,DriverFound[SelectedRom].driverName);
		StrCat(FileName,".ini");
		Exists = file_exists(FileName);
		
		if (Exists)
		{
			fp = fopen(FileName,"rb");
			fread(&GameOption.iCPUSpeed,sizeof(UInt8),1,fp);
			fread(&GameOption.iAudioSpeed,sizeof(UInt8),1,fp);
			fread(&GameOption.SoundOption,sizeof(UInt32),1,fp);
			fread(&GameOption.RotateOption,sizeof(UInt32),1,fp);
			fread(&GameOption.ScaleOption,sizeof(UInt8),1,fp);
			fread(&GameOption.MenuOption,sizeof(UInt8),1,fp);
			fread(&GameOption.Rating,sizeof(UInt8),1,fp);
			
			if (fp)	fclose(fp);
			return;

		}

	}
		
	StrCopy(FileName,"PalmMAME/ini/default.ini");
	
	Exists = file_exists(FileName);
	
	if (Exists)
	{
		fp = fopen(FileName,"rb");
		fread(&GameOption.iCPUSpeed,sizeof(UInt8),1,fp);
		fread(&GameOption.iAudioSpeed,sizeof(UInt8),1,fp);
		fread(&GameOption.SoundOption,sizeof(UInt32),1,fp);
		fread(&GameOption.RotateOption,sizeof(UInt32),1,fp);
		fread(&GameOption.ScaleOption,sizeof(UInt8),1,fp);
		fread(&GameOption.MenuOption,sizeof(UInt8),1,fp);
		fread(&GameOption.Rating,sizeof(UInt8),1,fp);
	}
	else
	{
		GameOption.iCPUSpeed=100;   
		GameOption.iAudioSpeed=100; 
		GameOption.SoundOption=44100; 
		GameOption.RotateOption=0;
		GameOption.ScaleOption=0; 
		GameOption.MenuOption=0;  
		GameOption.Rating=4;   //unrated
		SetGameConfigFile(1);
	} 

	if (fp)	fclose(fp);
}

void SetGameConfigFile(int defaultFlag)
{
	FILE *fp=NULL;
	char FileName[256];
	
	if (!defaultFlag)
	{
		StrCopy(FileName,"PalmMAME/ini/");
		StrCat(FileName,DriverFound[SelectedRom].driverName);
		StrCat(FileName,".ini");

		fp = fopen(FileName,"wb");
		if (fp)
		{
			zfwrite(&GameOption.iCPUSpeed,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.iAudioSpeed,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.SoundOption,sizeof(UInt32),1,fp);
			zfwrite(&GameOption.RotateOption,sizeof(UInt32),1,fp);
			zfwrite(&GameOption.ScaleOption,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.MenuOption,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.Rating,sizeof(UInt8),1,fp);
		}
	}
	else
	{
		StrCopy(FileName,"PalmMAME/ini/default.ini");
		CreateDirectory("PalmMAME/ini");
		fp = fopen(FileName,"wb");
		if (fp)
		{
			zfwrite(&GameOption.iCPUSpeed,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.iAudioSpeed,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.SoundOption,sizeof(UInt32),1,fp);
			zfwrite(&GameOption.RotateOption,sizeof(UInt32),1,fp);
			zfwrite(&GameOption.ScaleOption,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.MenuOption,sizeof(UInt8),1,fp);
			zfwrite(&GameOption.Rating,sizeof(UInt8),1,fp);
		}
	}
	if (fp) fclose(fp);

}


static Boolean RomConfigFormHandleEvent(EventType * eventP)
{
	Boolean handled = false;
	FormType * frmP = FrmGetActiveForm();
	char Temp3[20];
	ListType *list;
	char strDefaultNameLabel[40]="Default Options";
	ControlType *controlP;

	switch (eventP->eType) 
	{

		case frmOpenEvent:
			WinScreenLock(winLockCopy);
			FrmDrawForm(frmP);
			if (SelectedRom == -1)
				GetGameConfigFile(1);
			else
				GetGameConfigFile(0);
			StrCopy(strCPUSpeed,StrIToA(Temp3,GameOption.iCPUSpeed));
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,CPUSpeed) ),strCPUSpeed);
		
			StrCopy(strAudioSpeed,StrIToA(Temp3,GameOption.iAudioSpeed));
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,AudioSpeed) ),strAudioSpeed);

			if (SelectedRom >=0)
			{
				if (DriverFound)
				{
					CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RomConfigGameNameLabel) ),DriverFound[SelectedRom].driverLongName);
					CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RomConfigRomNameLabel) ),DriverFound[SelectedRom].driverName);
				}
			}
			else
			{
				controlP = (ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RomConfigGameNameLabel) );
				CtlSetLabel(controlP,"Default Options");

			}
			//Set Sound Option
			if (GameOption.SoundOption == 0)
				PushBOn(frmP,SoundOffPushButton);
			else if (GameOption.SoundOption == 11025)
				PushBOn(frmP,SoundLowPushButton);
			else if (GameOption.SoundOption == 22050)
				PushBOn(frmP,SoundMedPushButton);
			else if (GameOption.SoundOption == 44100)
				PushBOn(frmP,SoundHighPushButton);
				
			//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotateList) );
			LstSetSelection(list,GameOption.RotateOption);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

			//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,StatBarList) );
			LstSetSelection(list,GameOption.MenuOption);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,StatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
			
			//Rating
			list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RatingList) );
			LstSetSelection(list,GameOption.Rating);
			CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RatingPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
			
			if (GameOption.ScaleOption)
				PushBOn(frmP,MainScaleCheckbox);
			else
				PushBOff(frmP,MainScaleCheckbox);

			FrmDrawForm(frmP);
			WinScreenUnlock();
			
			break;

		case winEnterEvent:
		 	frmP = FrmGetActiveForm();

			if (ConfabReturn == 1)
			{
				StrCopy(strCPUSpeed,ConfabReturnString);
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,CPUSpeed) ),strCPUSpeed);
				GameOption.iCPUSpeed=StrAToI(strCPUSpeed);
				ConfabReturn = 0;
			}
			else if (ConfabReturn == 2)
			{
				StrCopy(strAudioSpeed,ConfabReturnString);
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,AudioSpeed) ),strAudioSpeed);
				GameOption.iAudioSpeed=StrAToI(strAudioSpeed);
				ConfabReturn = 0;
			}
			break;
		
		case ctlSelectEvent:
		{
			if (eventP->data.ctlSelect.controlID == SoundOffPushButton)
			{
				GameOption.SoundOption = 0;
				
			}
			else if (eventP->data.ctlSelect.controlID == SoundLowPushButton)
			{
				GameOption.SoundOption = 11025;
				
			}
			else if (eventP->data.ctlSelect.controlID == SoundMedPushButton)
			{
				GameOption.SoundOption = 22050;
				
			}
			else if (eventP->data.ctlSelect.controlID == SoundHighPushButton)
			{
				GameOption.SoundOption = 44100;
				
			}
			else if (eventP->data.ctlSelect.controlID == MainScaleCheckbox)
			{
				GameOption.ScaleOption = CtlGetValue((ControlPtr)GetObjectPtr(MainScaleCheckbox));
			}
			else if (eventP->data.ctlSelect.controlID == CPUSpeed)
			{
				ConfabReturn = 1;
				FrmPopupForm(ConfabulatorForm);
				break;
			}
			else if (eventP->data.ctlSelect.controlID == AudioSpeed)
			{
				ConfabReturn = 2;
				FrmPopupForm(ConfabulatorForm);
				break;
			}
			else if (eventP->data.ctlSelect.controlID == RomConfigOKButton)
			{
				if (SelectedRom == -1)
					SetGameConfigFile(1);
				else
					SetGameConfigFile(0);
				RomConfigReturn = 1;
				FrmReturnToForm(MainForm);
				handled = true;
				break;
			}
			else if (eventP->data.ctlSelect.controlID == RomConfigCancelButton)
			{
				RomConfigReturn = 1;
				FrmReturnToForm(MainForm);
				handled = true;
				break;
			}
			else if (eventP->data.ctlSelect.controlID == RomConfigDefaultButton)
			{
				GetGameConfigFile(1);
				StrCopy(strCPUSpeed,StrIToA(Temp3,GameOption.iCPUSpeed));
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,CPUSpeed) ),strCPUSpeed);
			
				StrCopy(strAudioSpeed,StrIToA(Temp3,GameOption.iAudioSpeed));
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,AudioSpeed) ),strAudioSpeed);

				//Set Sound Option
				PushBOff(frmP,SoundOffPushButton);
				PushBOff(frmP,SoundLowPushButton);
				PushBOff(frmP,SoundMedPushButton);
				PushBOff(frmP,SoundHighPushButton);
				
				if (GameOption.SoundOption == 0)
					PushBOn(frmP,SoundOffPushButton);
				else if (GameOption.SoundOption == 11025)
					PushBOn(frmP,SoundLowPushButton);
				else if (GameOption.SoundOption == 22050)
					PushBOn(frmP,SoundMedPushButton);
				else if (GameOption.SoundOption == 44100)
					PushBOn(frmP,SoundHighPushButton);
					
				//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
				list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotateList) );
				LstSetSelection(list,GameOption.RotateOption);
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

				//Set Rotation Option, 0 landcape, 1 Portrate, 2 auto (switch automatically depending on games preference
				list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,StatBarList) );
				LstSetSelection(list,GameOption.MenuOption);
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,StatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

				//Rating
				list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RatingList) );
				LstSetSelection(list,GameOption.Rating);
				CtlSetLabel((ControlType*)FrmGetObjectPtr(frmP,FrmGetObjectIndex(frmP,RatingPopup) ),LstGetSelectionText(list,LstGetSelection(list)));
				
				if (GameOption.ScaleOption)
					PushBOn(frmP,MainScaleCheckbox);
				else
					PushBOff(frmP,MainScaleCheckbox);


				FrmDrawForm(frmP);

				break;
			}


			break;
		}

		case popSelectEvent:
		{
            switch ( eventP->data.ctlSelect.controlID )
            {
                case RotatePopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotateList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RotatePopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					GameOption.RotateOption = eventP->data.popSelect.selection;

                }
				break;
				
				case StatBarPopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,StatBarList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,StatBarPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					GameOption.MenuOption = eventP->data.popSelect.selection;

                }
				break;

				case RatingPopup:
                {

                    ListType *list=(ListType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RatingList) );
                    CtlSetLabel((ControlType*)FrmGetObjectPtr ( frmP,FrmGetObjectIndex(frmP,RatingPopup) ),LstGetSelectionText(list,LstGetSelection(list)));

					GameOption.Rating = eventP->data.popSelect.selection;

                }
				break;
			}
			break;
		}


	}
	return handled;
}
/*
 * FUNCTION: AppHandleEvent
 *
 * DESCRIPTION: 
 *
 * This routine loads form resources and set the event handler for
 * the form loaded.
 *
 * PARAMETERS:
 *
 * event
 *     a pointer to an EventType structure
 *
 * RETURNED:
 *     true if the event was handled and should not be passed
 *     to a higher level handler.
 */

static Boolean AppHandleEvent(EventType * eventP)
{
	UInt16 formId;
	FormType * frmP;

	if (eventP->eType == frmLoadEvent)
	{
		/* Load the form resource. */
		formId = eventP->data.frmLoad.formID;
		frmP = FrmInitForm(formId);
		FrmSetActiveForm(frmP);

		/* 
		 * Set the event handler for the form.  The handler of the
		 * currently active form is called by FrmHandleEvent each
		 * time is receives an event. 
		 */
		switch (formId)
		{
			case MainForm:
				FrmSetEventHandler(frmP, MainFormHandleEvent);
				break;

			case SplashForm:
				FrmSetEventHandler(frmP, SplashFormHandleEvent);
				break;
				
			case ConfigForm:
				FrmSetEventHandler(frmP, ConfigFormHandleEvent);
				break;
			case MESSForm:
				FrmSetEventHandler(frmP, MESSFormHandleEvent);
				break;
			case ConfabulatorForm:
				FrmSetEventHandler(frmP, ConfabulatorFormHandleEvent);
				break;
			case RomConfigForm:
				FrmSetEventHandler(frmP, RomConfigFormHandleEvent);
				break;

		}
		return true;
	}

	return false;
}

/*
 * FUNCTION: AppEventLoop
 *
 * DESCRIPTION: This routine is the event loop for the application.
 */

static void AppEventLoop(void)
{
	UInt16 error;
	EventType event;

	do 
	{
		/* change timeout if you need periodic nilEvents */
		EvtGetEvent(&event, 1);

		if (! SysHandleEvent(&event))
		{
			if (! MenuHandleEvent(0, &event, &error))
			{
				if (! AppHandleEvent(&event))
				{
					FrmDispatchEvent(&event);
				}
			}
		}
	} while (event.eType != appStopEvent);
}

/*
 * FUNCTION: AppStart
 *
 * DESCRIPTION:  Get the current application's preferences.
 *
 * RETURNED:
 *     errNone - if nothing went wrong
 */

static Err AppStart(void)
{
    UInt16 	prefsSize;
    Int16 	version;
    UInt16	count1=0;
    UInt16	CountDrivers = 0;
    Err error=0;
    //LocalID theDBID;
	//UInt theCardNo;
	//DmSearchStateType theSearchState;
	Int16	ModuleNum=0;
	RectangleType rect;
	char *text[80];
	
	RctSetRectangle(&rect,20,20,120,30);
	
	ModuleNum = 0;

	while(ModuleNum <13)
	{
	

		prefsSize = sizeof(Int16);
		version = PrefGetAppPreferences(appFileCreator, AppLastModuleListed, &ModuleNum, &prefsSize, true);
		if (version == noPreferenceFound || prefsSize != sizeof(Int16))
		{
			ModuleNum = -1;
			FrmCustomAlert(10024,"Checking for PMAME modules.  ","This will take some time and the screen may flicker.","");			
		}
		
		if (ModuleNum<13)	
			++ModuleNum;
		
		SetModuleName(ModuleNum);
		PrefSetAppPreferences (appFileCreator, AppLastModuleListed, appPrefVersionNum, 
			&ModuleNum, sizeof (Int16), true);
		
		if (ModuleNum < 12)
		{
			//No prefs - Get modules to list contents
			GameIndex = (-1);
			PrefSetAppPreferences (appFileCreator, AppRunGameIndex, appPrefVersionNum, 
				&GameIndex, sizeof (Int16), true);
			
			
			StrPrintF(text,"Reading %s",StrChr(FullModuleName,'/'));
			WinEraseRectangle(&rect,0);
			WinDrawRectangleFrame(dialogFrame,&rect);
			WinDrawChars(text,StrLen(text),30,30);
			
			MameCallPno();
				
		
		}
		else
		{
			prefsSize = sizeof(UInt16);
			version = PrefGetAppPreferences(appFileCreator, AppModuleSizePref, &TotalGames, &prefsSize, true);
			if (version == noPreferenceFound || prefsSize != sizeof(UInt16))
			{
			
			}
			else
			{

				//ak Changing to file-based options
				GetGameConfigFile(1);//1 means default options
				
				

				//Prefs are there, load them for the list
				prefsSize = sizeof(DriverListType) * TotalGames;
				if (DriverList)
				{
					MemPtrFree(DriverList);
				}
				DriverList = (DriverListType *)MemGluePtrNew(sizeof(DriverListType) * TotalGames);
				version = PrefGetAppPreferences(appFileCreator, AppDriverList, DriverList, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(DriverListType) * TotalGames)
				{
					//Error, there should be a list the size of the Total Games -- screwed up prefs!

				}
				/*
				//Load Sound Options
				prefsSize = sizeof(UInt32);
				version = PrefGetAppPreferences(appFileCreator, AppSoundOption, &SoundOption, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(UInt32))
				{
					//Not Found
					SoundOption = 0;
					
				}
				else
					SoundOption = ByteSwap32(SoundOption);
				
				//Load Rotation Options
				prefsSize = sizeof(UInt32);
				version = PrefGetAppPreferences(appFileCreator, AppRotateOption, &RotateOption, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(UInt32))
				{
					//Not Found
					RotateOption = 0;
					
				}
				else
					RotateOption = ByteSwap32(RotateOption);
				
				//Load Scale Options
				prefsSize = sizeof(UInt8);
				version = PrefGetAppPreferences(appFileCreator, AppScale, &ScaleFlag, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(UInt8))
				{
					//Not Found
					ScaleFlag = 0;
					
				}*/
				//Load Key Options
				prefsSize = sizeof(KeyStruct);
				version = PrefGetAppPreferences(appFileCreator, AppKeyOption, &KeyStruct, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(KeyStruct))
				{
					//Not Found
					MemSet(KeyStruct,sizeof(KeyStruct),0);
					
				}
				else
				{
					int keycount = 0;
					
					for (keycount = 0;keycount<15;keycount++)
					{
						KeyStruct[keycount].Key = ByteSwap32(KeyStruct[keycount].Key);
					
					}
				}
				/*
				//Load Menu Options
				prefsSize = sizeof(UInt8);
				version = PrefGetAppPreferences(appFileCreator, AppMenuOption, &MenuOption, &prefsSize, true);
				if (version == noPreferenceFound || prefsSize != sizeof(UInt8))
				{
					//Not Found
					MenuOption = 1;
					
				}*/

			}
		}
	}


	return errNone;
}

/*
 * FUNCTION: AppStop
 *
 * DESCRIPTION: Save the current state of the application.
 */

static void AppStop(void)
{
	
	MemPtrFree(FileList);

	//Save current position of rows displayed
	PrefSetAppPreferences (appFileCreator, AppTopRow, appPrefVersionNum, 
		&TopVisibleRow, sizeof (TopVisibleRow), true);

	if (DriverList)
	{
		MemPtrFree(DriverList);
		DriverList = NULL;
	}
	
	if (DriverFound)
	{
		MemPtrFree(DriverFound);
		DriverFound = NULL;
	}
        
	/* Close all the open forms. */
	FrmCloseAllForms();

}



UInt32 PilotMain(UInt16 cmd, MemPtr cmdPBP, UInt16 launchFlags)
{
	Err error;

	switch (cmd)
	{
		case sysAppLaunchCmdNormalLaunch:
		
			error = RomVersionCompatible (ourMinVersion, launchFlags);
			if (error) 
				return (error);
				
			CountROMS = CountROMFiles();
			
			screen_init();

			error = AppStart();
			if (error) 
				return error;

			/* 
			 * start application by opening the main form
			 * and then entering the main event loop 
			 */
			FrmGotoForm(SplashForm);
			AppEventLoop();

			AppStop();
			break;
	}

	return errNone;
}
