/*
 * PalmMameLoader.h
 *
 * header file for PalmMameLoader
 *
 * This wizard-generated code is based on code adapted from the
 * stationery files distributed as part of the Palm OS SDK 4.0.
 *
 * Copyright (c) 1999-2000 Palm, Inc. or its subsidiaries.
 * All rights reserved.
 */
 
#ifndef PALMMAMELOADER_H_
#define PALMMAMELOADER_H_

/*********************************************************************
 * Internal Structures
 *********************************************************************/


/*********************************************************************
 * Global variables
 *********************************************************************/
Char* SafeStrCat ( Char *dst, const Char *src, UInt16 maxLengthWithNull, char *theFile, long theLine );
Char* SafeStrCopy (Char* dst, const Char* src, UInt16 maxLengthWithNull, char *theFile, long theLine);
void hw_guess_screen_dimensions ( /*UInt32 *r_width, UInt32 *r_height,
				   UInt32 *r_pitch*/ );
static void SetAppColours();
static void endDrawOffscreen();
static void createScreenBuffer();
static void MamePlayGameSD(Int16 GameNum, UInt8 Module);
static void MESSPlayGame();
void *hw_query_vram ( void );
void GetGameConfigFile(int defaultFlag);
void SetGameConfigFile(int defaultFlag);
void DrawRatings();

/*********************************************************************
 * Internal Constants
 *********************************************************************/

#ifdef _TAPWAVEBUILD_
#define appFileCreator			'ZODM'
#else
#define appFileCreator			'PDac'
#endif
#define appName					"PalmMameLoader"
//AK defines for getting and setting preferences for driver database
#define appPrefVersionNum	2	//AK Set application prefs version here

#define AppModuleSizePref	0x01
#define AppDriverList		0x02
#define AppRunGameIndex		0x03
#define AppLastModuleListed	0x04
#define AppSoundOption		0x05 //UInt16 holding Sound Hz
#define AppRotateOption		0x06 //UInt16 holding orientation
#define AppTopRow			0x07 //UInt16 holding last row displayed
#define AppRanMame			0x08 //Program just started flag, for displaying splash
#define AppFilter			0x09 //Program just started flag, for displaying splash
#define AppScale			0x10 //UInt8 holding scale (1=scale, 0=noscale)
#define AppKeyOption		0x11 //Struct holding key assignments
#define AppMenuOption		0x12 //UInt8 holding menu orientation (0=none, 1=horiz, 2=vert)
#define AppCPUSpeed			0x13
#define AppAudioSpeed		0x14 //UInt8 holding CPU and Audio percent of speed (under/overclock)

//MESS
#define AppMESSCommandLine	0x20	//Holds the command line string (max 256);


#define FTR_BT_PORT_ID       0x30
#define FTR_BT_PORT_OPEN_ID  0x31
#define FTR_SER_PORT_ID      0x32
#define FTR_SER_PORT_OPEN_ID 0x33
#define FTR_IR_PORT_ID       0x34
#define FTR_IR_PORT_OPEN_ID  0x35
#define FTR_OPT_INPUTCONF_TREO_ID 0x36

#define FTR_OPT_BTGP_USED_ID     0x35
#define FTR_OPT_BTGP_CLOSED_ID   0x36
#define FTR_OPT_SERIAL_PORTID_ID 0x37
#define FTR_OPT_IRKB_USED_ID     0x38
#define FTR_OPT_IRKB_CONFIG_ID   0x39



/*
 * This is the generic creator for Tapwave products, assigned by PalmSource
 */
#define twCreatorID             'Tpwv'
#define twFtrCreator            twCreatorID

/*
 * This is the PalmOS feature number for TapWave API version.
 */
#define twFtrAPIVersion         0x0000

// for calling back from pno to host
typedef struct {
  UInt32 a;
  UInt32 b;
  UInt32 c;
  UInt32 d;
} hostcall_t;

typedef struct {
  UInt32 a;
  UInt32 b;
  UInt32 c;
  UInt32 d;
  UInt32 e;
  UInt32 f;
  UInt32 g;
  UInt32 h;
  UInt32 i;
} bighostcall_t;
// for requesting data from the 68k side, from the pnolet
#define BRIDGESHIFT 6
#define BRIDGEMASK  0x3F

enum{
  BRIDGE_SrmSend=1,
  BRIDGE_SrmReceive,
  BRIDGE_SrmReceiveCheck,
  BRIDGE_TreoKey
};



#endif /* PALMMAMELOADER_H_ */
