#ifndef __PLAYGAME_H__
#define __PLAYGAME_H__

#include "mamePalm.h"

#define SOUND_NONE   0
#define SOUND_WAVE   (SOUND_NONE + 1)


struct tMAMEApp
{
	//HINSTANCE				m_hInstance;
    //HWND                    m_hwndUI;
    //HWND                    m_hWnd;
    //const char*             m_Name;
	int						m_nSpeed;	/* Current game speed percentage */
    struct OSDDisplay*      m_pDisplay;
    struct OSDSound*        m_pSound;
    struct OSDKeyboard*     m_pKeyboard;
    struct OSDJoystick*     m_pJoystick;
    struct OSDTrak*         m_pTrak;
    struct OSDFMSynth*      m_pFMSynth;
    BOOL                    m_bIsInitialized;
	BOOL					m_bIsActive;
	BOOL					m_bIsPaused;
    BOOL                    m_bDone;

};


typedef struct
{
    double gamma;
    int brightness;
	int depth;
	int screendepth;
    int scale;
    int rotate;
	int sound;
    int sample_rate;
    int volume;
	int  frame_skip;
	int DevID;
	BOOL stereo;
	BOOL no_fm;
	BOOL auto_frame_skip;
 	BOOL showfps;
	BOOL hscan_lines;
//	BOOL auto_pause;
	BOOL profile;
	BOOL use_dirty;

} options_type;


extern struct tMAMEApp MAMEApp;

#ifdef __cplusplus
extern "C" {
#endif

//extern void MamePlayGame(int index, struct ui_options* UI);

extern void ErrorMsg(const char* fmt, ...);
extern options_type * GetPlayingGameOptions();

//extern HWND CreateMAMEWindow(void);
extern void MAMEApp_init(void);
extern BOOL MAME_Done(void);
extern void MAME_Quit(void);
extern void MamePlayGame(int index/*, struct ui_options* UI*/);

//extern void MAMECE3_ProcessMessages(void);
//extern LRESULT CALLBACK MAMECE3_MessageProc(HWND, UINT, WPARAM, LPARAM);
#ifdef __cplusplus
}
#endif



#endif